	SUBROUTINE CHIMAT(IQPNT)
**************************************************************
*  Computes susceptibility matrix.                           *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NRAD(NSORTMAX),NITER(0:NENVMAX,-1:2)
     &   ,INDGPTB(0:NENVMAX)
	COMPLEX*16 EXPQR,YLM(LMMAXV)
     &   ,DPOTPS(0:NPLWMAX,NSPINMAX),DBXCPS(0:NPLWMAX,NSPINMAX)
     &   ,DRHOPS(0:NPLWMAX,NSPINMAX),DMAGPS(0:NPLWMAX,NSPINMAX)
     &   ,DPOT(0:NRADMAX,LMMAXV,NPAT,NSPINMAX),WORK1(0:NRADMAX)
     &   ,DBXC(0:NRADMAX,LMMAXV,NPAT,NSPINMAX),WORK2(0:NRADMAX)
     &   ,DRHO(0:NRADMAX,LMMAXV,NPAT,NSPINMAX),GINT,TR(-1:1,3)
     &   ,DMAG(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,CHIINT(0:NENVMAX,-1:2,0:NENVMAX,-1:2)
     &   ,CHIMTS(0:NENVMAX,-1:2,0:NENVMAX,-1:2)
     &   ,CHITOT(0:NENVMAX,-1:2,0:NENVMAX,-1:2)
     &   ,DHIINT(0:NENVMAX, 0:3,0:NENVMAX, 0:3)
     &   ,DHIMTS(0:NENVMAX, 0:3,0:NENVMAX, 0:3)
     &   ,DHITOT(0:NENVMAX, 0:3,0:NENVMAX, 0:3)
	DIMENSION H(NSORTMAX),R(0:NRADMAX,NSORTMAX)
     &   ,SMT(NSORTMAX),RL(0:NRADMAX,0:LMAXV,NSORTMAX)
     &   ,DR(0:NRADMAX,NSORTMAX),WEIGHT(0:NRADMAX,NSORTMAX)
     &   ,ORTH(2:3),GPLW(3,0:NPLWMAX),TAU(3,NPAT),QPNT(3)
     &   ,BES(0:LMAXV),BESD(0:LMAXV),GPTB(3,0:NENVMAX)
        CHARACTER TXTEL(NSORTMAX)*10,TXTSP(2)*2
     &   ,POLS(-1:2)*1,POLC(0:3)*1
C Controls:
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE        !!! from readini
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from readini
        COMMON /MAGCOM/ ITERMAX,NITER                       !!! from readlrt
	COMMON /ORBS/   NORBS                               !!! from readini
	COMMON /SPIN/   NSPIN                               !!! from readini
C Inputs:
	COMMON /POTCOM/ SWZ,SMT                             !!! from readini
        COMMON /QMESH/  NQPNT,QPNT                          !!! from qvector
        COMMON /PTBCOM/ NGSHL,NGPTB,GPTB,INDGPTB            !!! from plwptb
        COMMON /LATPAR/ PAR,ORTH,OMEGAC                     !!! from init
        COMMON /BASIS/  TAU                                 !!! from readstr
C Radial mesh:
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL               !!! from radmsh
C Plane waves:
        COMMON /PLWMESH/NPLW,GPLW                           !!! from plwmsh
C Induced density:
	COMMON /DELRO/  DRHO,DMAG                           !!! from delrho
        COMMON /DPSRHO/ DRHOPS,DMAGPS                       !!! from vcftr
C Induced potential:
	COMMON /DELPOT/ DPOT,DBXC                           !!! from delpot
        COMMON /DPSVCOM/DPOTPS,DBXCPS                       !!! from dvcftr
C Frequency:
        COMMON /FREQU/  OMGR                                !!! from init
C Outputs:
        COMMON /TXTEL/  TXTEL,TXTSP                         !!! from readini
	COMMON /UNIT/   IUN                                 !!! from readini
	DATA PI/3.141592653589793D0/
        DATA TR/(+0.70710678118655D0, 0.00000000000000D0)
     &         ,( 0.00000000000000D0, 0.00000000000000D0)
     &         ,(-0.70710678118655D0, 0.00000000000000D0)
     &         ,( 0.00000000000000D0,+0.70710678118655D0)
     &         ,( 0.00000000000000D0, 0.00000000000000D0)
     &         ,( 0.00000000000000D0,+0.70710678118655D0)
     &         ,( 0.00000000000000D0, 0.00000000000000D0)
     &         ,( 1.00000000000000D0, 0.00000000000000D0)
     &         ,( 0.00000000000000D0, 0.00000000000000D0)/
        DATA POLS/'m','z','p','v'/,POLC/'0','x','y','z'/
	SQPI4=2.D0*SQRT(PI)
	DO 3000 MY=-1,2                     !!! over polarizations
	DO 2000 IGPTB=0,NGPTB               !!! over g-vectors
C SET SUSCEPTIBILITY TO ZERO
	DO MY1=-1,2
	DO IGPTB1=0,NGPTB
	CHIMTS(IGPTB1,MY1,IGPTB,MY)=(0.D0,0.D0)
	CHIINT(IGPTB1,MY1,IGPTB,MY)=(0.D0,0.D0)
	ENDDO
	ENDDO
	IF(NITER(IGPTB,MY).EQ.0)GOTO2000
C SET PLANE WAVE EXP(iqR) AS AN EXPANSION OVER SPHERICAL HARMONICS
	DO 1000 IGPTB1=0,NGPTB              !!! over g-vectors
	DO IATOM=1,NATOM                    !!! over all atoms in cell
	ISORT=IS(IATOM)
        QX=(QPNT(1)+GPTB(1,IGPTB1))*2.D0*PI/PAR
        QY=(QPNT(2)+GPTB(2,IGPTB1))*2.D0*PI/PAR
        QZ=(QPNT(3)+GPTB(3,IGPTB1))*2.D0*PI/PAR
        AQ=SQRT(QX**2+QY**2+QZ**2)
        IF(AQ.GE.1.D-10)THEN
        CALL SPHHARM(QX/AQ,QY/AQ,QZ/AQ,ILSV(ISORT),YLM)
        ELSE
        YLM(1)=1.D0/SQRT(4.D0*PI)
        DO LM=2,(ILSV(ISORT)+1)**2
        YLM(LM)=(0.D0,0.D0)
        ENDDO
        ENDIF
        SCP=(QPNT(1)+GPTB(1,IGPTB1))*TAU(1,IATOM)+
     &      (QPNT(2)+GPTB(2,IGPTB1))*TAU(2,IATOM)+
     &      (QPNT(3)+GPTB(3,IGPTB1))*TAU(3,IATOM)
        EXPQR=EXP((0.D0,1.D0)*2.D0*PI*SCP)
C SET PLANE WAVE EXP(iqR) AS AN EXPANSION OVER SPHERICAL HARMONICS
	DO IRAD=0,NRAD(ISORT)               !!! over radial mesh
        CALL BESSR(AQ*R(IRAD,ISORT),BES(0),BESD(0),ILSV(ISORT))
	DO L=0,ILSV(ISORT)                  !!! over l
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
        DPOT(IRAD,LM,IATOM,1)=4.D0*PI*BES(L)*
     &  EXPQR*DCONJG(YLM(LM))
        ENDDO                               !!! over m
        ENDDO                               !!! over l
	ENDDO                               !!! over radial mesh
        ENDDO                               !!! over all atoms in cell
C SET INTEGRALS OVER MT-SPHERES
	CALL DROFILES(IGPTB,MY,IQPNT,33,'R')
	DO IATOM=1,NATOM                    !!! over all atoms in cell
	ISORT=IS(IATOM)
	DO L=0,ILSV(ISORT)                  !!! over l
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
C SPIN-UP DENSITY
	DO IRAD=0,NRAD(ISORT)               !!! over radial mesh
        WORK1(IRAD)=DRHO(IRAD,LM,IATOM,1)*
     &  DCONJG(DPOT(IRAD,LM,IATOM,1))*
     &  R(IRAD,ISORT)**2*DR(IRAD,ISORT)
	ENDDO                               !!! over radial mesh
        CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	CHIMTS(IGPTB1,0,IGPTB,MY)=CHIMTS(IGPTB1,0,IGPTB,MY)+
     &  WORK2(NRAD(ISORT))
	CHIMTS(IGPTB1,2,IGPTB,MY)=CHIMTS(IGPTB1,2,IGPTB,MY)+
     &  WORK2(NRAD(ISORT))
C SPIN-DN DENSITY
	DO IRAD=0,NRAD(ISORT)               !!! over radial mesh
        WORK1(IRAD)=DRHO(IRAD,LM,IATOM,NSPIN)*
     &  DCONJG(DPOT(IRAD,LM,IATOM,1))*
     &  R(IRAD,ISORT)**2*DR(IRAD,ISORT)
	ENDDO                               !!! over radial mesh
        CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	CHIMTS(IGPTB1,0,IGPTB,MY)=CHIMTS(IGPTB1,0,IGPTB,MY)-
     &  WORK2(NRAD(ISORT))
	CHIMTS(IGPTB1,2,IGPTB,MY)=CHIMTS(IGPTB1,2,IGPTB,MY)+
     &  WORK2(NRAD(ISORT))
C <<->> MAGNETIZATION
	DO IRAD=0,NRAD(ISORT)               !!! over radial mesh
        WORK1(IRAD)=DMAG(IRAD,LM,IATOM,1)*
     &  DCONJG(DPOT(IRAD,LM,IATOM,1))*
     &  R(IRAD,ISORT)**2*DR(IRAD,ISORT)
	ENDDO                               !!! over radial mesh
        CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	CHIMTS(IGPTB1,-1,IGPTB,MY)=CHIMTS(IGPTB1,-1,IGPTB,MY)+
     &  WORK2(NRAD(ISORT))
C <<+>> MAGNETIZATION
	DO IRAD=0,NRAD(ISORT)               !!! over radial mesh
        WORK1(IRAD)=DMAG(IRAD,LM,IATOM,NSPIN)*
     &  DCONJG(DPOT(IRAD,LM,IATOM,1))*
     &  R(IRAD,ISORT)**2*DR(IRAD,ISORT)
	ENDDO                               !!! over radial mesh
        CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	CHIMTS(IGPTB1,+1,IGPTB,MY)=CHIMTS(IGPTB1,+1,IGPTB,MY)+
     &  WORK2(NRAD(ISORT))
        ENDDO                               !!! over m
        ENDDO                               !!! over l
        ENDDO                               !!! over atoms
C ADD CONTRIBUTION FROM THE INTERSTITIAL REGION
	CALL DPSFILES(IGPTB,MY,IQPNT,35,'R')
        DO IPLW=0,NPLW                      !!! over plane waves
        CALL PLWMTS(GPLW(1,IPLW)-GPTB(1,IGPTB1) 
     &             ,GPLW(2,IPLW)-GPTB(2,IGPTB1) 
     &             ,GPLW(3,IPLW)-GPTB(3,IGPTB1),GINT)
C SPIN-UP DENSITY
	CHIINT(IGPTB1, 0,IGPTB,MY)=CHIINT(IGPTB1, 0,IGPTB,MY)+
     &  GINT*DRHOPS(IPLW,1)    
	CHIINT(IGPTB1, 0,IGPTB,MY)=CHIINT(IGPTB1, 0,IGPTB,MY)-
     &  GINT*DRHOPS(IPLW,NSPIN)
	CHIINT(IGPTB1, 2,IGPTB,MY)=CHIINT(IGPTB1, 2,IGPTB,MY)+
     &  GINT*DRHOPS(IPLW,1)    
	CHIINT(IGPTB1, 2,IGPTB,MY)=CHIINT(IGPTB1, 2,IGPTB,MY)+
     &  GINT*DRHOPS(IPLW,NSPIN)
	CHIINT(IGPTB1,-1,IGPTB,MY)=CHIINT(IGPTB1,-1,IGPTB,MY)+
     &  GINT*DMAGPS(IPLW,1)
	CHIINT(IGPTB1,+1,IGPTB,MY)=CHIINT(IGPTB1,+1,IGPTB,MY)+
     &  GINT*DMAGPS(IPLW,NSPIN)
	ENDDO                              !!! over plane waves
1000	CONTINUE                           !!! over g-vectors
2000	CONTINUE                           !!! over g-vectors
3000	CONTINUE                           !!! over polarizations
C TRANSFORM TO CARTESIAN SYSTEM
	DO 5000 IGPTB1=0,NGPTB             !!! over g-vectors
	DO 4000 IGPTB =0,NGPTB             !!! over g-vectors
C FIELD-FIELD
        DO IX1=1,3                         !!! over x,y,z
        DO IX=1,3                          !!! over x,y,z
        DHIMTS(IGPTB1,IX1,IGPTB,IX)=(0.0,0.0)
        DHIINT(IGPTB1,IX1,IGPTB,IX)=(0.0,0.0)
        DO MY1=-1,1                        !!! over -1,0,1
        DO MY=-1,1                         !!! over -1,0,1
        DHIMTS(IGPTB1,IX1,IGPTB,IX)=DHIMTS(IGPTB1,IX1,IGPTB,IX)+
     &  CHIMTS(IGPTB1,MY1,IGPTB,MY)*TR(MY1,IX1)*TR(MY,IX)
        DHIINT(IGPTB1,IX1,IGPTB,IX)=DHIINT(IGPTB1,IX1,IGPTB,IX)+
     &  CHIINT(IGPTB1,MY1,IGPTB,MY)*TR(MY1,IX1)*TR(MY,IX)
        ENDDO                              !!! over -1,0,1
        ENDDO                              !!! over -1,0,1
        ENDDO                              !!! over x,y,z
        ENDDO                              !!! over x,y,z
C FIELD-SCALAR
        DO IX1=1,3                         !!! over x,y,z
        DO IX=0,0                          !!! over x,y,z
        DHIMTS(IGPTB1,IX1,IGPTB,IX)=(0.0,0.0)
        DHIINT(IGPTB1,IX1,IGPTB,IX)=(0.0,0.0)
        DO MY1=-1,1                        !!! over -1,0,1
        DO MY=2,2                          !!! over -1,0,1
        DHIMTS(IGPTB1,IX1,IGPTB,IX)=DHIMTS(IGPTB1,IX1,IGPTB,IX)+
     &  CHIMTS(IGPTB1,MY1,IGPTB,MY)*TR(MY1,IX1)
        DHIINT(IGPTB1,IX1,IGPTB,IX)=DHIINT(IGPTB1,IX1,IGPTB,IX)+
     &  CHIINT(IGPTB1,MY1,IGPTB,MY)*TR(MY1,IX1)
        ENDDO                              !!! over -1,0,1
        ENDDO                              !!! over -1,0,1
        ENDDO                              !!! over x,y,z
        ENDDO                              !!! over x,y,z
C SCALAR-FIELD
        DO IX1=0,0                         !!! over x,y,z
        DO IX=1,3                          !!! over x,y,z
        DHIMTS(IGPTB1,IX1,IGPTB,IX)=(0.0,0.0)
        DHIINT(IGPTB1,IX1,IGPTB,IX)=(0.0,0.0)
        DO MY1=2,2                         !!! over -1,0,1
        DO MY=-1,1                         !!! over -1,0,1
        DHIMTS(IGPTB1,IX1,IGPTB,IX)=DHIMTS(IGPTB1,IX1,IGPTB,IX)+
     &  CHIMTS(IGPTB1,MY1,IGPTB,MY)*TR(MY,IX)
        DHIINT(IGPTB1,IX1,IGPTB,IX)=DHIINT(IGPTB1,IX1,IGPTB,IX)+
     &  CHIINT(IGPTB1,MY1,IGPTB,MY)*TR(MY,IX)
        ENDDO                              !!! over -1,0,1
        ENDDO                              !!! over -1,0,1
        ENDDO                              !!! over x,y,z
        ENDDO                              !!! over x,y,z
C SCALAR-SCALAR
        DO IX1=0,0                         !!! over x,y,z
        DO IX=0,0                          !!! over x,y,z
        DHIMTS(IGPTB1,IX1,IGPTB,IX)=(0.0,0.0)
        DHIINT(IGPTB1,IX1,IGPTB,IX)=(0.0,0.0)
        DO MY1=2,2                         !!! over -1,0,1
        DO MY =2,2                         !!! over -1,0,1
        DHIMTS(IGPTB1,IX1,IGPTB,IX)=DHIMTS(IGPTB1,IX1,IGPTB,IX)+
     &  CHIMTS(IGPTB1,MY1,IGPTB,MY)
        DHIINT(IGPTB1,IX1,IGPTB,IX)=DHIINT(IGPTB1,IX1,IGPTB,IX)+
     &  CHIINT(IGPTB1,MY1,IGPTB,MY)
        ENDDO                              !!! over -1,0,1
        ENDDO                              !!! over -1,0,1
        ENDDO                              !!! over x,y,z
        ENDDO                              !!! over x,y,z
4000	CONTINUE                           !!! over g-vectors
5000	CONTINUE                           !!! over g-vectors
C PRINT SUSCEPTIBILITY
	DO IGPTB=0,NGPTB
C	DO IGPTB1=0,NGPTB
 	DO IGPTB1=IGPTB,IGPTB ! only diagonals
        IF(MODE.NE.4)WRITE(IUN,1011)IGPTB,IGPTB1
        IF(MODE.EQ.4)WRITE(IUN,1012)IGPTB,IGPTB1
1011    FORMAT(1X,'** COMPLEX SUSCEPTIBILITY Chi(q+G',
     &  I2,',g+G',I2,',omega) **')
1012    FORMAT(1X,'** IMAGINARY SUSCEPTIBILITY Im[chi(q+G',
     &  I2,',q+G',I2,',omega)] **')
        WRITE(IUN,1013)(QPNT(I),I=1,3)
        WRITE(IUN,1014)IGPTB,GPTB(1,IGPTB),
     &  GPTB(2,IGPTB),GPTB(3,IGPTB)
        WRITE(IUN,1014)IGPTB1,GPTB(1,IGPTB1),
     &  GPTB(2,IGPTB1),GPTB(3,IGPTB1)
        WRITE(IUN,1015)OMGR,OMGR*13605.8D0
1013    FORMAT(1X,'Q-VECTOR: (',G11.4,',',G11.4,',',G11.4,')')
1014    FORMAT(1X,'G',I2,'=(',G12.5,',',G12.5,',',G12.5,')')
1015    FORMAT(1X,'FREQUENCY =',G14.7,' Ry ; ',G14.7,' meV.')
        WRITE(IUN,1016)(POLS(MY),MY=-1,2)
        DO MY1=-1,2
        WRITE(IUN,1017)POLS(MY1),
     &  (CHIMTS(IGPTB1,MY1,IGPTB,MY)+
     &   CHIINT(IGPTB1,MY1,IGPTB,MY),MY=-1,2)
        ENDDO
C       WRITE(IUN,1016)(POLC(IX),IX=0,3)
C       DO IX1=0,3
C       WRITE(IUN,1017)POLC(IX1),
C    &  (DHIMTS(IGPTB1,IX1,IGPTB,IX)+
C    &   DHIINT(IGPTB1,IX1,IGPTB,IX),IX=0,3)
C       ENDDO
	ENDDO 
	ENDDO
1016    FORMAT(4X,11X,A1,11X,11X,A1,11X,11X,A1,11X,11X,A1)
1017    FORMAT(1X,A1,1X,2G11.4,'|',2G11.4,'|',2G11.4,'|',2G11.4)
	END
