	SUBROUTINE DTOSEND(IGPTB,MY,IPAN,IQPNT)
***********************************************************
*  Makes final pseudodensity by adding LS,SL and LL terms.*
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,IND(LIMLMB,NPAT,NKAPMAX,NSPINMAX,NPANMAX),ILSV(NSORTMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,LBAS(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,NKAP(NPANMAX),NDIV(3),NDIW(3)
	COMPLEX*16 EKAP(NKAPMAX,NPANMAX),EK(NKAPMAX,NPANMAX)
     &    ,DRHOPS(0:NPLWMAX,NSPINMAX),DMAGPS(0:NPLWMAX,NSPINMAX)
     &    ,YLM0(LIMLMB,0:NBASMAX),YLMQ(LIMLMB,0:NBASMAX)
     &    ,CFTR0(0:LMAXB,NSORTMAX,NKAPMAX,0:NBASMAX)
     &    ,CFTRQ(0:LMAXB,NSORTMAX,NKAPMAX,0:NBASMAX)
     &    ,EXP0(0:NBASMAX),CHI0(0:NBASMAX),EXS0(0:NBASMAX)
     &    ,EXPQ(0:NBASMAX),CHIQ(0:NBASMAX),EXSQ(0:NBASMAX)
     &    ,DCON(0:NBASMAX),CHIS(0:NBASMAX)
     &    ,DRFUN0(NDIMMAX,0:MBASMAX),DRINT0Q(NDIMMAX,NDIMMAX)
     &    ,DRFUNQ(NDIMMAX,0:MBASMAX)
	DIMENSION TAU(3,NPAT),GPLW(3,0:NPLWMAX),SMT(NSORTMAX)
     &    ,PNTR(3),PNTK(3),PNT(3,KMAX),WGT(KMAX),ORTH(2:3)
     &    ,ETA(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),QPNT(3)
     &    ,CUT(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)       
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
        CHARACTER SCNFILE(0:NENVMAX,-1:2,100)*60
C Controls:
	COMMON /CONTROL/MAN,LMTO,NLR,NOVR,NPF,MODE           !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from init
	COMMON /SPIN/   NSPIN                                !!! from init
	COMMON /ORBS/   NORBS                                !!! from init
C Inputs:
	COMMON /BASIS/  TAU                                  !!! from init
	COMMON /POTCOM/ SWZ,SMT                              !!! from init
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                      !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                    !!! from init
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                    !!! from init
	COMMON /INDX/   IND                                  !!! from lmtpar
C Density:
	COMMON /DPSRHO/ DRHOPS,DMAGPS                        !!! from dtosint
C Plane waves:
	COMMON /PLWMESH/NPLW,GPLW                            !!! from plwmsh
	COMMON /TEILORG/KEYT,BZM,GOPT,MBAS                   !!! from teipar
	COMMON /ETAPAR/ ETA,CUT,LBAS,NBAS                    !!! from plwmsh
C K-mesh:
	COMMON /MESH/   NPNT,PNT,WGT                         !!! from ttrmsh
	COMMON /QMESH/  NQPNT,QPNT                           !!! from qvector
	COMMON /INTTR/  NDIV,NDIW                            !!! from init
C Temporary:
	COMMON /DENS/   PNTR,CFTR0,YLM0                      !!! from ftrmat
	COMMON /STORE2/ CFTRQ,YLMQ                           !!! tmp.storage
	COMMON /STORE1/ DRFUN0,DRFUNQ,DRINT0Q                !!! from dtosint
C Outputs:
        COMMON /OUT0PH/ SCNFILE                              !!! from init
	COMMON /UNIT/   IUN                                  !!! from init
	COMMON /WORD/   NVAL                                 !!! from nmtdata
	DATA PI/3.141592653589793D0/
	IF(KEYT.EQ.0)RETURN
	IF(MODE.EQ.5)RETURN
	LMB=0
	DO ISORT=1,NSORT
	DO IKAP=1,NKAP(IPAN)
	DO L=0,ILSB(ISORT)
	IF(LSPAN(L,ISORT,IKAP,IPAN))LMB=MAX(L,LMB)
	ENDDO
	ENDDO
	ENDDO
C  SET PSEUDOLMTOS FOR THE POINT IPNTK
	PNTK(1)=QPNT(1)
	PNTK(2)=QPNT(2)
	PNTK(3)=QPNT(3)
	CALL FTRMAT(PNTK,1,IPAN)
	DO IBAS=0,NBAS
	DO L=0,LMB
	DO M=-L,L
	LM=L*(L+1)+M+1
	YLMQ(LM,IBAS)=YLM0(LM,IBAS)
	ENDDO
	ENDDO
	ENDDO
	DO ISORT=1,NSORT                  !!! over isort
	DO IKAP=1,NKAP(IPAN)              !!! over ikap
	DO L=0,ILSB(ISORT)                !!! over l
	DO IBAS=0,LBAS(L,ISORT,IKAP,IPAN) !!! over ibas
	CFTRQ(L,ISORT,IKAP,IBAS)=CFTR0(L,ISORT,IKAP,IBAS)
	ENDDO                             !!! over ibas
	ENDDO                             !!! over l
	ENDDO                             !!! over ikap
	ENDDO                             !!! over isort
C  SET PSEUDOLMTOS FOR THE POINT IPNTK
	PNTK(1)=0.D0
	PNTK(2)=0.D0
	PNTK(3)=0.D0
	CALL FTRMAT(PNTK,1,IPAN)
C  OPEN SCRATCH FILE
        NRECL=NVAL*(2*NBNDT(IPAN)*(MIN(NBAS,MBAS)+1)+
     &  NBNDT(IPAN)**2)
        OPEN(UNIT=47,FILE=SCNFILE(IGPTB,MY,47),STATUS='OLD',
     &  ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
        OPEN(UNIT=48,FILE=SCNFILE(IGPTB,MY,48),STATUS='OLD',
     &  ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
        CALL DPSFILES(IGPTB,MY,IQPNT,35,'R')       !!! read pseudodensity
C ***** DO GLOBALLY OVER SPINORS ********
        DO 6000 IUPDN1=1,NSPIN                     !!! over spinors
        DO 5000 IUPDN =1,NSPIN                     !!! over spinors
C SET LONGITUDINAL AND TRANSVERSE COMPONENTS
            IF(IUPDN1.EQ.1.AND.IUPDN.EQ.1)THEN
        IF(NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2)GOTO5000
        ISPIN=1
        ITRAN=0
        ELSEIF(IUPDN1.EQ.2.AND.IUPDN.EQ.2)THEN
        IF(NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2)GOTO5000
        ISPIN=2
        ITRAN=0
        ELSEIF(IUPDN1.EQ.1.AND.IUPDN.EQ.2)THEN
        IF(NORBS.EQ.1.AND.MY.NE.+1)GOTO5000
        ISPIN=0
        ITRAN=1
        ELSEIF(IUPDN1.EQ.2.AND.IUPDN.EQ.1)THEN
        IF(NORBS.EQ.1.AND.MY.NE.-1)GOTO5000
        ISPIN=0
        ITRAN=2
        ENDIF
C  READ DENSITY PARAMETERS
        IREC=ISPIN
        IF(ISPIN.NE.0)
     &  READ(47,REC=IREC)((DRINT0Q(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,
     &  IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS)),
     &  ((DRFUNQ(IPAR1,IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,
     &  MIN(NBAS,MBAS))
        IREC=ITRAN
        IF(ITRAN.NE.0)
     &  READ(48,REC=IREC)((DRINT0Q(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,
     &  IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS)),
     &  ((DRFUNQ(IPAR1,IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,
     &  MIN(NBAS,MBAS))
C  DO OVER LEFT INDEX
	DO 4000 IATOM1=1,NATOM                      !!! over iatom1
	ISORT1=IS(IATOM1)
C  CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,NBAS
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM1)+
     &      (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM1)+
     &      (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM1)
	EXP0(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	SCP=(GPLW(1,IBAS)+QPNT(1))*TAU(1,IATOM1)+
     &      (GPLW(2,IBAS)+QPNT(2))*TAU(2,IATOM1)+
     &      (GPLW(3,IBAS)+QPNT(3))*TAU(3,IATOM1)
	EXPQ(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
	DO 3000 IKAP1=1,NKAP(IPAN)                  !!! over energy
	DO 2000 L1=0,ILSB(ISORT1)                   !!! over l1
	DO 1000 M1=-L1,L1                           !!! over m1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))EXIT
	L1M1=L1*(L1+1)+M1+1
	IPAR1=IND(L1M1,IATOM1,IKAP1,1,IPAN)
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
	DO IBAS=MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN)   !!! NG_1{large}
	CHI0(IBAS)=DCONJG(CFTR0(L1,ISORT1,IKAP1,IBAS)*
     &  YLM0(L1M1,IBAS)*EXP0(IBAS))
	CHIQ(IBAS)=CFTRQ(L1,ISORT1,IKAP1,IBAS)*
     &  YLMQ(L1M1,IBAS)*EXPQ(IBAS)
	ENDDO
C  FOURIER TRANSFORM OF THE PSEUDOCHARGE DENSITY
C  LS CONTRIBUTION
        DO JBAS=0,MIN(NBAS,MBAS)
        CHIS(JBAS)=DRFUN0(IPAR1,JBAS)
        ENDDO
	IF(ISPIN.NE.0)
     &  CALL CONVOL2(DRHOPS(0,ISPIN),CHIS(0),CHIQ(0),'P',
     &  0,MIN(NBAS,MBAS),MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
	IF(ITRAN.NE.0)
     &  CALL CONVOL2(DMAGPS(0,ITRAN),CHIS(0),CHIQ(0),'P',
     &  0,MIN(NBAS,MBAS),MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
C  SL CONTRIBUTION
        DO IBAS=0,MIN(NBAS,MBAS)
        CHIS(IBAS)=DRFUNQ(IPAR1,IBAS)
        ENDDO
	IF(ISPIN.NE.0)
     &  CALL CONVOL2(DRHOPS(0,ISPIN),CHI0(0),CHIS(0),'P',
     &  MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN),0,MIN(NBAS,MBAS))
	IF(ITRAN.NE.0)
     &  CALL CONVOL2(DMAGPS(0,ITRAN),CHI0(0),CHIS(0),'P',
     &  MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN),0,MIN(NBAS,MBAS))
C  SET CONVOLUTION OF PSEUDOORBITAL WITH TOS-MATRIX
	DO IBAS=0,NBAS
	DCON(IBAS)=(0.D0,0.D0)
	ENDDO
	DO IATOM=1,NATOM                           !!! over iatom
	ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,NBAS                             !!! NGMAX{large}
	SCP=(GPLW(1,IBAS)+QPNT(1))*TAU(1,IATOM)+
     &      (GPLW(2,IBAS)+QPNT(2))*TAU(2,IATOM)+
     &      (GPLW(3,IBAS)+QPNT(3))*TAU(3,IATOM)
	EXSQ(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
	DO IKAP=1,NKAP(IPAN)                       !!! over energy
	DO L=0,ILSB(ISORT)                         !!! over l
	DO M=-L,L                                  !!! over m
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
	LM=L*(L+1)+M+1
	IPAR=IND(LM,IATOM,IKAP,1,IPAN)
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)     !!! NG{large}
	CHIQ(IBAS)=CFTRQ(L,ISORT,IKAP,IBAS)*
     &  YLMQ(LM,IBAS)*EXSQ(IBAS)
	ENDDO
C  CONVOLUTION
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)
	DCON(IBAS)=DCON(IBAS)+DRINT0Q(IPAR1,IPAR)*CHIQ(IBAS)
	ENDDO
	ENDDO                                      !!! over m
	ENDDO                                      !!! over l
	ENDDO                                      !!! over energy
	ENDDO                                      !!! over iatom
C  4) LARGE-LARGE G CONTRIBUTION
	IF(ISPIN.NE.0)
     &  CALL CONVOL2(DRHOPS(0,ISPIN), CHI0(0),DCON(0),'P',
     &  MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN),MBAS+1,NBAS)
	IF(ITRAN.NE.0)
     &  CALL CONVOL2(DMAGPS(0,ITRAN), CHI0(0),DCON(0),'P',
     &  MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN),MBAS+1,NBAS)
1000    CONTINUE                                   !!! over m1
2000    CONTINUE                                   !!! over l1
3000    CONTINUE                                   !!! over energy
4000    CONTINUE                                   !!! over iatom1
5000    CONTINUE                                   !!! over spinors
6000    CONTINUE                                   !!! over spinors
C  STORE PSEUDODENSITY
        CALL DPSFILES(IGPTB,MY,IQPNT,35,'W')       !!! store pseudodensity
	CLOSE(47)
	CLOSE(48)
	END
