	SUBROUTINE DTOSINT(IGPTB,MY,IPNT,ISGQ,IPAN,IQPNT)
***********************************************************
*  Calculate change in the pseudocharge density           *
*  due to presense of frozen phonon with q-vector number. *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,IKOV(NOPRMAX),ISG(NOPRMAX,NOPRMAX),IS(NPAT)
     &   ,IG0IG1(KMAX,NOPRMAX),IK0IK1(KMAX,NOPRMAX)
     &   ,IND(LIMLMB,NPAT,NKAPMAX,NSPINMAX,NPANMAX)
     &   ,LBAS(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,NKAP(NPANMAX),NBNDC(NPANMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &   ,PSIK(0:NBASMAX,NORBSMAX,NDIMMAX*NSPINMAX),WT1
     &   ,PSIQ(0:NBASMAX,NORBSMAX,NDIMMAX*NSPINMAX),WT2
     &   ,APSI(0:NBASMAX),SPSI(0:NBASMAX),CTMP1,CTMP2
     &   ,DHMAT(NDIMMAX*NSPINMAX,NDIMMAX*NSPINMAX)
     &   ,DOMAT(NDIMMAX*NSPINMAX,NDIMMAX*NSPINMAX)
     &   ,DRHOPS(0:NPLWMAX,NSPINMAX),DMAGPS(0:NPLWMAX,NSPINMAX)
     &   ,DRINT0Q(NDIMMAX,NDIMMAX),AFUN(NDIMMAX),SFUN(NDIMMAX)
     &   ,DRFUN0(NDIMMAX,0:MBASMAX),DRFUNQ(NDIMMAX,0:MBASMAX)
     &   ,CHIS(0:NBASMAX)
        COMPLEX*16
     &    APHK(LIMLMB ,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &   ,APJK(LIMLMT1,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &   ,APHQ(LIMLMB ,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &   ,APJQ(LIMLMT1,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
	DIMENSION PNT(3,KMAX),EARR(NDIMMAX*NSPINMAX,KMAX,NPANMAX)
     &   ,ETA(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),PNTR(3),PNTK(3)
     &   ,CUT(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),PNTQ(3),QPNT(3)
     &   ,WEIGQ(NBNDMAX*NSPINMAX,NBNDMAX*NSPINMAX,6),WGT(KMAX)
     &   ,WGTOM(NBNDMAX*NSPINMAX,NBNDMAX*NSPINMAX,4),ORTH(2:3)
     &   ,WEIGK(NBNDMAX*NSPINMAX,4),GPLW(3,0:NPLWMAX),TAU(3,NPAT)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX),LOG1,LOG
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX),EXIST
	CHARACTER SCNFILE(0:NENVMAX,-1:2,100)*60,STATUS*3
C Controls:
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE           !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM          !!! from init
	COMMON /ORBS/   NORBS                                  !!! from init
	COMMON /SPIN/   NSPIN                                  !!! from init
C Inputs:
	COMMON /BASIS/  TAU
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                      !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                  !!! from init
        COMMON /LATPAR/ PAR,ORTH,OMEGAC                        !!! from init
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT,NBNDC,POLUS          !!! from init
        COMMON /INDX/   IND                                    !!! from lmtpar
C K-mesh:
	COMMON /MESH/   NPNT,PNT,WGT                           !!! from ttrmsh
        COMMON /QMESH/  NQPNT,QPNT                             !!! from qvector
	COMMON /SYMMESH/IG0IG1,IK0IK1                          !!! from symmsh
C Bands:
	COMMON /ENERGY/ EARR                                   !!! from delttr
        COMMON /EIGVEC/ APHK,APJK,APHQ,APJQ                    !!! from lmtvec
C Group:
	COMMON /INVERS/ INV,IKOV                               !!! from group
	COMMON /SUBGROUP/NSGQ,NGEQ,ISG                         !!! from symmsh
	COMMON /GROUPOUT/NGROUP                                !!! from group
C Plane waves:
	COMMON /PLWMESH/NPLW,GPLW                              !!! from plwmsh
        COMMON /ETAPAR/ ETA,CUT,LBAS,NBAS                      !!! from plwmsh
        COMMON /TEILORG/KEYT,BZM,GOPT,MBAS                     !!! from teipar
C Density
	COMMON /DPSRHO/ DRHOPS,DMAGPS                          !!! from dtosint
C Temporary:
        COMMON /STORE1/ DRFUN0,DRFUNQ,DRINT0Q                  !!! from dtosint
	COMMON /STORE2/ DHMAT,DOMAT                            !!! from delmat
	COMMON /DELRO/  PSIK,PSIQ,PNTK,PNTQ                    !!! from psivec
C Frequenciy:
	COMMON /FREQU/  OMGR                                   !!! from init
C Outputs:
	COMMON /OUT0PH/ SCNFILE                                !!! from init
	COMMON /WORD/   NVAL                                   !!! from nmtdata
	DATA PI/3.141592653589793D0/
	IF(MODE.EQ.5)RETURN
C  SET POINT-GROUP INFORMATION
	IRK=ISG(1,ISGQ)       !!!  element "g"  in the main G-list
	IGK=IKOV(IRK)         !!!  element "g"  after Kovalev
	IPNTK=IPNT            !!!  point   "k"
	IRQ=IG0IG1(IPNT,IRK)  !!!  element "g'" in the main G-list
	IGQ=IKOV(IRQ)         !!!  element "g'" after Kovalev
	IPNTQ=IK0IK1(IPNT,IRK)!!!  point   "k'" such that g*k+q=g'*k'
C  READ 1/E TETRAHEDRON WEIGHTS FOR BRILLOUIN ZONE INTEGRATION
        IREC=1+IPNTK+NPNT*(ISGQ-1)
        IF(IPAN.EQ.1)THEN
        READ(40,REC=IREC)WGTQ1,(((WEIGQ(IBANC,IBANC1,IC),
     &  IBANC=1,NBNDC(1)*NSPIN),IBANC1=1,NBNDC(1)*NSPIN),
     &  IC=1,6),((WEIGK(IBANC,IC),IBANC=1,NBNDC(1)*NSPIN),
     &  IC=1,4),(((WGTOM(IBANC,IBANC1,IC),IBANC=1,
     &  NBNDC(1)*NSPIN),IBANC1=1,NBNDC(1)*NSPIN),IC=1,4)
        ELSE ! only geometrical weigths are neccessary
        READ(40,REC=IREC)WGTQ1
        ENDIF
C  OPEN SCRATCH FILE
        NRECL=NVAL*(2*NBNDT(IPAN)*(MIN(NBAS,MBAS)+1)+
     &  NBNDT(IPAN)**2)
        OPEN(UNIT=47,FILE=SCNFILE(IGPTB,MY,47),STATUS='OLD',
     &  ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
        OPEN(UNIT=48,FILE=SCNFILE(IGPTB,MY,48),STATUS='OLD',
     &  ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
        CALL DPSFILES(IGPTB,MY,IQPNT,35,'R')            !!! read change in pseudod
C ***** DO GLOBALLY OVER SPINORS ********
        DO 4000 IUPDN1=1,NSPIN                          !!! over spinors
        IF(NORBS.EQ.2)IORBS1=IUPDN1
        IF(NORBS.EQ.1)IORBS1=1
        DO 3000 IUPDN =1,NSPIN                          !!! over spinors
        IF(NORBS.EQ.2)IORBS=IUPDN
        IF(NORBS.EQ.1)IORBS=1
C SET LONGITUDINAL AND TRANSVERSE COMPONENTS
            IF(IUPDN1.EQ.1.AND.IUPDN.EQ.1)THEN
        IF(NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2)GOTO3000
        ISPIN=1
        ITRAN=0
        SIGNF=1.D0
        ELSEIF(IUPDN1.EQ.2.AND.IUPDN.EQ.2)THEN
        IF(NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2)GOTO3000
        ISPIN=2
        ITRAN=0
        SIGNF=1.D0
        ELSEIF(IUPDN1.EQ.1.AND.IUPDN.EQ.2)THEN
        IF(NORBS.EQ.1.AND.MY.NE.+1)GOTO3000
        ISPIN=0
        ITRAN=1
        SIGNF=+SQRT(2.D0)
        ELSEIF(IUPDN1.EQ.2.AND.IUPDN.EQ.1)THEN
        IF(NORBS.EQ.1.AND.MY.NE.-1)GOTO3000
        ISPIN=0
        ITRAN=2
        SIGNF=-SQRT(2.D0)
        ENDIF
C  READ DENSITY PARAMETERS
        IREC=ISPIN
        IF(KEYT.GT.0.AND.ISPIN.NE.0)
     &  READ(47,REC=IREC)((DRINT0Q(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,
     &  IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS)),
     &  ((DRFUNQ(IPAR1,IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,
     &  MIN(NBAS,MBAS))
        IREC=ITRAN
        IF(KEYT.GT.0.AND.ITRAN.NE.0)
     &  READ(48,REC=IREC)((DRINT0Q(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,
     &  IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS)),
     &  ((DRFUNQ(IPAR1,IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,
     &  MIN(NBAS,MBAS))
C  **** CALCULATE CONTRIBUTION TO THE CHANGE IN PSEUDODENSITY
C  **** FROM A SINGLE K-POINT OF BZ AND ALL BAND TRASITIONS 
        DO 2000 IBNDS=1,NSPIN                          !!! over spin subbands
	DO 1000 IBNDT=1,NBNDF(IPAN)                    !!! over filled bands
	IBNDC=IBNDT-NBNDE(IPAN)+1
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
C  CALCULATE CONVOLUTIONS OVER BANDS
	DO IBAS=0,MIN(NBAS,MBAS)                        !!! over plane waves
	APSI(IBAS)=(0.D0,0.D0)
	SPSI(IBAS)=(0.D0,0.D0)
	ENDDO
        DO IPAR=1,NBNDT(IPAN)
        AFUN(IPAR)=(0.D0,0.D0)
        SFUN(IPAR)=(0.D0,0.D0)
        ENDDO
C  1) CALCULATE CONTRIBUTION FROM UNOCCUPIED STATES
	DO IBNDS1=1,NSPIN                              !!! over spin subbands
	DO IBNDT1=NBNDE(IPAN),NBNDT(IPAN)              !!! over empty bands
	IF(IPAN.GT.1)STOP'<DTOSINT>: Error in empty bands for ipan>1'
	IBNDC1=IBNDT1-NBNDE(IPAN)+1
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
C  FOR THE FERMI SURFACE BANDS
        IF(IBNDT.GE.NBNDE(IPAN).AND.IBNDT1.LE.NBNDF(IPAN))THEN
	DEK1=OMGR+EARR(IBAND,IPNTK,IPAN)-EARR(IBAND1,IPNTQ,IPAN)
        DEK2=OMGR+EARR(IBAND1,IPNTK,IPAN)-EARR(IBAND,IPNTQ,IPAN)
C  1/E TETRAHEDRON WEIGHTS
        WQ1=   +WEIGQ(IBANC,IBANC1,1) !!! f(kj)*[1-f(k+qj')]/[E(kj)-E(k+qj')]
        WQ2=   +WEIGQ(IBANC1,IBANC,2) !!! [1-f(kj')]*f(k+qj)/[E(kj')-E(k+qj)]
C  WEIGHTS FROM DENSITY-OF-STATES AT EF
        WQ1=WQ1+WEIGQ(IBANC,IBANC1,3) !!! +0.5*Delta[E(kj )-Ef]
        WQ2=WQ2+WEIGQ(IBANC1,IBANC,4) !!! -0.5*Delta[E(kj')-Ef]
C  WEIGHTS FROM LORENTZIAN SMEARING
        WQ1=WQ1+WEIGK(IBANC,1)*DEK1/(DEK1**2+POLUS**2) !!! f(kj)
        WQ2=WQ2+WEIGK(IBANC,2)*DEK2/(DEK2**2+POLUS**2) !!! f(k+qj')
        WQ1=WQ1-WEIGQ(IBANC,IBANC1,5) !!! f(kj)*[1-f(k+qj')]/[E(kj)-E(k+qj')]
        WQ2=WQ2-WEIGQ(IBANC1,IBANC,6) !!! [1-f(kj')]*f(k+qj)/[E(kj')-E(k+qj)]
C  WEIGHTS FROM THE IMAGINARY PART
        WI1=-PI*WGTOM(IBANC,IBANC1,1) !!! (f(kj)-f(k+qj')*d(E(kj)-E(k+qj')+Omega)
        WI2=0.D0                      !!! (f(kj')-f(k+qj)*d(E(kj')-E(k+qj)+Omega)
C  OTHERWISE, USUAL TETRAHEDRON WEIGHTS
	ELSEIF(IBNDT.GE.NBNDE(IPAN).AND.IBNDT1.GT.NBNDF(IPAN))THEN
	DEK1=OMGR+EARR(IBAND,IPNTK,IPAN)-EARR(IBAND1,IPNTQ,IPAN)
        DEK2=OMGR+EARR(IBAND1,IPNTK,IPAN)-EARR(IBAND,IPNTQ,IPAN)
                IF(ABS(DEK1).LE.1.D-10)THEN
                IF(ABS(WEIGK(IBANC,1)).GE.1.D-10)
     &          PRINT*,'<DTOSINT> :: ERROR IN WEIGHTS'
                WEIGK(IBANC,1)=0.D0
                DEK1=1.D0
                ENDIF
                IF(ABS(DEK2).LE.1.D-10)THEN
                IF(ABS(WEIGK(IBANC,2)).GE.1.D-10)
     &          PRINT*,'<DTOSINT> :: ERROR IN WEIGHTS'
                WEIGK(IBANC,2)=0.D0
                DEK2=1.D0
                ENDIF
	WQ1=WEIGK(IBANC,1)/DEK1     !!! f(kj)  /[E(kj)-E(k+qj')]
	WQ2=WEIGK(IBANC,2)/DEK2     !!! f(k+qj)/[E(kj')-E(k+qj)]
        WI1=0.D0
        WI2=0.D0
	ELSEIF(IBNDT.LT.NBNDE(IPAN).AND.IBNDT1.LE.NBNDF(IPAN))THEN
	DEK1=OMGR+EARR(IBAND,IPNTK,IPAN)-EARR(IBAND1,IPNTQ,IPAN)
        DEK2=OMGR+EARR(IBAND1,IPNTK,IPAN)-EARR(IBAND,IPNTQ,IPAN)
                IF(ABS(DEK1).LE.1.D-10)THEN
                IF(ABS(WGTQ1-WEIGK(IBANC1,2)).GE.1.D-10)
     &          PRINT*,'<DTOSINT> :: ERROR IN WEIGHTS'
                WEIGK(IBANC1,2)=WGTQ1
                DEK1=1.D0
                ENDIF
                IF(ABS(DEK2).LE.1.D-10)THEN
                IF(ABS(WGTQ1-WEIGK(IBANC1,1)).GE.1.D-10)
     &          PRINT*,'<DTOSINT> :: ERROR IN WEIGHTS'
                WEIGK(IBANC1,1)=WGTQ1
                DEK1=1.D0
                ENDIF
	WQ1=(WGTQ1-WEIGK(IBANC1,2))/DEK1 !!! [1-f(k+qj')]/[E(kj)-E(k+qj')]
	WQ2=(WGTQ1-WEIGK(IBANC1,1))/DEK2 !!! [1-f(kj')  ]/[E(kj')-E(k+qj)]
        WI1=0.D0
        WI2=0.D0
	ELSEIF(IBNDT.LT.NBNDE(IPAN).AND.IBNDT1.GT.NBNDF(IPAN))THEN
	DEK1=OMGR+EARR(IBAND,IPNTK,IPAN)-EARR(IBAND1,IPNTQ,IPAN)
        DEK2=OMGR+EARR(IBAND1,IPNTK,IPAN)-EARR(IBAND,IPNTQ,IPAN)
	WQ1=WGTQ1/DEK1              !!! 1/[E(kj)-E(k+qj')]
	WQ2=WGTQ1/DEK2              !!! 1/[E(kj')-E(k+qj)]
        WI1=0.D0
        WI2=0.D0
	ENDIF
C  SET TOTAL COMPLEX WEIGHT
        IF(MODE.EQ.1.OR.MODE.EQ.2.OR.MODE.EQ.3)THEN
        WT1=DCMPLX(WQ1,WI1)
        WT2=DCMPLX(WQ2,WI2)
C  COMPUTE IMAGINARY PART ONLY
        ELSEIF(MODE.EQ.4)THEN
        WT1=DCMPLX(WI1,0.D0)
        WT2=DCMPLX(WI2,0.D0)
        ENDIF
C  SET UP CONTRIBUTION
        ESUM1=OMGR+EARR(IBAND,IPNTK,IPAN)+EARR(IBAND1,IPNTQ,IPAN)
        ESUM2=OMGR+EARR(IBAND1,IPNTK,IPAN)+EARR(IBAND,IPNTQ,IPAN)
	CTMP1=(DHMAT(IBAND1,IBAND)-0.5D0*ESUM1*
     &  DOMAT(IBAND1,IBAND))*WT1*SIGNF
	CTMP2=(DHMAT(IBAND,IBAND1)-0.5D0*ESUM2*
     &  DOMAT(IBAND,IBAND1))*WT2*SIGNF
	DO IBAS=0,MIN(NBAS,MBAS)
        IF((IUPDN1.EQ.IBNDS1.AND.NORBS.EQ.1).OR.NORBS.EQ.2)
     &  APSI(IBAS)=APSI(IBAS)+PSIQ(IBAS,IORBS1,IBAND1)*CTMP1
        IF((IUPDN.EQ.IBNDS1.AND.NORBS.EQ.1).OR.NORBS.EQ.2)
     &  SPSI(IBAS)=SPSI(IBAS)+CONJG(PSIK(IBAS,IORBS,IBAND1))*
     &  CTMP2
	ENDDO
        IF(KEYT.GT.0)THEN
        DO IATOM=1,NATOM
        ISORT=IS(IATOM)
        SCP=PNTK(1)*TAU(1,IATOM)+
     &      PNTK(2)*TAU(2,IATOM)+
     &      PNTK(3)*TAU(3,IATOM)
        EXPK0=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
        DO IKAP=1,NKAP(IPAN)
        DO L=0,ILSB(ISORT)
        IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
        DO M=-L,L
        LM=L*(L+1)+M+1
        IPAR=IND(LM,IATOM,IKAP,1,IPAN)
        IF((IUPDN1.EQ.IBNDS1.AND.NORBS.EQ.1).OR.NORBS.EQ.2)
     &  AFUN(IPAR)=AFUN(IPAR)+
     &  APHQ(LM,IATOM,IKAP,IORBS1,IBAND1)*EXPK0*CTMP1
        IF((IUPDN.EQ.IBNDS1.AND.NORBS.EQ.1).OR.NORBS.EQ.2)
     &  SFUN(IPAR)=SFUN(IPAR)+
     &  DCONJG(APHK(LM,IATOM,IKAP,IORBS,IBAND1)*EXPK0)*CTMP2
        ENDDO
        ENDIF
        ENDDO
        ENDDO
        ENDDO
        ENDIF
        ENDDO                                          !!! over empty bands
        ENDDO                                          !!! over spin bands
C  2) CONTRIBUTION FROM ALL STATES
	DO IBNDS1=1,NSPIN                              !!! over spin subbands
	DO IBNDT1=1,NBNDT(IPAN)                        !!! over all bands
	IBNDC1=IBNDT1-NBNDE(IPAN)+1
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
        IF(IBNDT.GE.NBNDE(IPAN))THEN
        WQ1=WEIGK(IBANC,1)          !!! f(kj)
        WQ2=WEIGK(IBANC,2)          !!! f(k+qj)
        WI1=0.D0
        WI2=0.D0
        ELSEIF(IBNDT.LT.NBNDE(IPAN))THEN
        WQ1=WGTQ1                   !!! 1
        WQ2=WGTQ1                   !!! 1
        WI1=0.D0
        WI2=0.D0
        ENDIF
C  SET TOTAL COMPLEX WEIGHT
        IF(MODE.EQ.1.OR.MODE.EQ.2.OR.MODE.EQ.3)THEN
        WT1=DCMPLX(WQ1,WI1)
        WT2=DCMPLX(WQ2,WI2)
C  COMPUTE IMAGINARY PART ONLY
        ELSEIF(MODE.EQ.4)THEN
        WT1=DCMPLX(WI1,0.D0)
        WT2=DCMPLX(WI2,0.D0)
        ENDIF
C  SET UP CONTRIBUTION
	CTMP1=-0.5D0*DOMAT(IBAND1,IBAND)*WT1*SIGNF
	CTMP2=+0.5D0*DOMAT(IBAND,IBAND1)*WT2*SIGNF
	DO IBAS=0,MIN(NBAS,MBAS)
        IF((IUPDN1.EQ.IBNDS1.AND.NORBS.EQ.1).OR.NORBS.EQ.2)
     &  APSI(IBAS)=APSI(IBAS)+PSIQ(IBAS,IORBS1,IBAND1)*
     &  CTMP1
        IF((IUPDN.EQ.IBNDS1.AND.NORBS.EQ.1).OR.NORBS.EQ.2)
     &  SPSI(IBAS)=SPSI(IBAS)+CONJG(PSIK(IBAS,IORBS,IBAND1))*
     &  CTMP2
	ENDDO
        IF(KEYT.GT.0)THEN
        DO IATOM=1,NATOM
        ISORT=IS(IATOM)
        SCP=PNTK(1)*TAU(1,IATOM)+
     &      PNTK(2)*TAU(2,IATOM)+
     &      PNTK(3)*TAU(3,IATOM)
        EXPK0=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
        DO IKAP=1,NKAP(IPAN)
        DO L=0,ILSB(ISORT)
        IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
        DO M=-L,L
        LM=L*(L+1)+M+1
        IPAR=IND(LM,IATOM,IKAP,1,IPAN)
        IF((IUPDN1.EQ.IBNDS1.AND.NORBS.EQ.1).OR.NORBS.EQ.2)
     &  AFUN(IPAR)=AFUN(IPAR)+
     &  APHQ(LM,IATOM,IKAP,IORBS1,IBAND1)*EXPK0*CTMP1
        IF((IUPDN.EQ.IBNDS1.AND.NORBS.EQ.1).OR.NORBS.EQ.2)
     &  SFUN(IPAR)=SFUN(IPAR)+
     &  DCONJG(APHK(LM,IATOM,IKAP,IORBS,IBAND1)*EXPK0)*CTMP2
        ENDDO
        ENDIF
        ENDDO
        ENDDO
        ENDDO
        ENDIF
        ENDDO                                          !!! over all bands
        ENDDO                                          !!! over spin subbands
C FOURIER TRANSFORM OF THE PSEUDOCHARGE DENSITY (SMALL G-VECTORS)
        IF(ISPIN.NE.0)THEN
C CHANGE IN SPIN DENSITY 1.
        IF((IUPDN.EQ.IBNDS.AND.NORBS.EQ.1).OR.NORBS.EQ.2)THEN
        DO IBAS=0,MIN(NBAS,MBAS)
        CHIS(IBAS)=DCONJG(PSIK(IBAS,IORBS,IBAND))
        ENDDO
        CALL CONVOL2(DRHOPS(0,ISPIN),CHIS(0),APSI(0),'P',
     &               0,MIN(NBAS,MBAS),0,MIN(NBAS,MBAS))
	ENDIF
        IF((IUPDN1.EQ.IBNDS.AND.NORBS.EQ.1).OR.NORBS.EQ.2)THEN
        DO IBAS=0,MIN(NBAS,MBAS)
        CHIS(IBAS)=PSIQ(IBAS,IORBS1,IBAND)
        ENDDO
        CALL CONVOL2(DRHOPS(0,ISPIN),SPSI(0),CHIS(0),'M',
     &               0,MIN(NBAS,MBAS),0,MIN(NBAS,MBAS))
	ENDIF
	ENDIF
        IF(ITRAN.NE.0)THEN
C CHANGE IN TRANSVERSE MAGNETIZATTION 1.
        IF((IUPDN.EQ.IBNDS.AND.NORBS.EQ.1).OR.NORBS.EQ.2)THEN
        DO IBAS=0,MIN(NBAS,MBAS)
        CHIS(IBAS)=DCONJG(PSIK(IBAS,IORBS,IBAND))
        ENDDO
        CALL CONVOL2(DMAGPS(0,ITRAN),CHIS(0),APSI(0),'P',
     &               0,MIN(NBAS,MBAS),0,MIN(NBAS,MBAS))
	ENDIF
C CHANGE IN TRANSVERSE MAGNETIZATTION 2.
        IF((IUPDN1.EQ.IBNDS.AND.NORBS.EQ.1).OR.NORBS.EQ.2)THEN
        DO IBAS=0,MIN(NBAS,MBAS)
        CHIS(IBAS)=PSIQ(IBAS,IORBS1,IBAND)
        ENDDO
        CALL CONVOL2(DMAGPS(0,ITRAN),SPSI(0),CHIS(0),'M',
     &               0,MIN(NBAS,MBAS),0,MIN(NBAS,MBAS))
	ENDIF
	ENDIF
C SET DENSITY PARAMETERS
        IF(KEYT.GT.0)THEN
        DO IATOM=1,NATOM
        ISORT=IS(IATOM)
        SCP=PNTK(1)*TAU(1,IATOM)+
     &      PNTK(2)*TAU(2,IATOM)+
     &      PNTK(3)*TAU(3,IATOM)
        EXPK0=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
        DO IKAP=1,NKAP(IPAN)
        DO L=0,ILSB(ISORT)
        DO M=-L,L
        IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
        LM=L*(L+1)+M+1
        IPAR=IND(LM,IATOM,IKAP,1,IPAN)
        DO IBAS=0,MIN(NBAS,MBAS)
        DRFUN0(IPAR,IBAS)=DRFUN0(IPAR,IBAS)+
     &  DCONJG(PSIK(IBAS,IORBS,IBAND))*AFUN(IPAR)-
     &  SPSI(IBAS)*APHQ(LM,IATOM,IKAP,IORBS1,IBAND)*EXPK0
        DRFUNQ(IPAR,IBAS)=DRFUNQ(IPAR,IBAS)+
     &  DCONJG(APHK(LM,IATOM,IKAP,IORBS,IBAND)*EXPK0)*APSI(IBAS)-
     &  SFUN(IPAR)*PSIQ(IBAS,IORBS1,IBAND)
        ENDDO
        DO IATOM1=1,NATOM
        ISORT1=IS(IATOM1)
        SCP=PNTK(1)*TAU(1,IATOM1)+
     &      PNTK(2)*TAU(2,IATOM1)+
     &      PNTK(3)*TAU(3,IATOM1)
        EXPK1=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
        DO IKAP1=1,NKAP(IPAN)
        DO L1=0,ILSB(ISORT1)
        DO M1=-L1,L1
        IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))EXIT
        L1M1=L1*(L1+1)+M1+1
        IPAR1=IND(L1M1,IATOM1,IKAP1,1,IPAN)
        DRINT0Q(IPAR1,IPAR)=DRINT0Q(IPAR1,IPAR)+
     &  DCONJG(APHK(L1M1,IATOM1,IKAP1,IORBS,IBAND)*EXPK1)*AFUN(IPAR)-
     &  SFUN(IPAR1)*APHQ(LM,IATOM,IKAP,IORBS1,IBAND)*EXPK0
        ENDDO
        ENDDO
        ENDDO
        ENDDO
        ENDDO
        ENDDO
        ENDDO
        ENDDO
        ENDIF
1000    CONTINUE                                       !!! over filled bands
2000    CONTINUE                                       !!! over spin subbands
C  STORE DENSITY PARAMETERS
        IREC=ISPIN
        IF(KEYT.GT.0.AND.ISPIN.NE.0)
     &  WRITE(47,REC=IREC)((DRINT0Q(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,
     &  IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS)),
     &  ((DRFUNQ(IPAR1,IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,
     &  MIN(NBAS,MBAS))
        IREC=ITRAN
        IF(KEYT.GT.0.AND.ITRAN.NE.0)
     &  WRITE(48,REC=IREC)((DRINT0Q(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,
     &  IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS)),
     &  ((DRFUNQ(IPAR1,IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,
     &  MIN(NBAS,MBAS))
3000    CONTINUE                                       !!! over spinors
4000    CONTINUE                                       !!! over spinors
        CALL DPSFILES(IGPTB,MY,IQPNT,35,'W')           !!! store change in pseudod
	CLOSE(47)
	CLOSE(48)
	RETURN




        ENTRY DSNULINT(IGPTB,MY,IPAN,IQPNT)
************************************************
*  Zeroises density parameters                 *
************************************************
C  OPEN SCRATCH FILE FOR STORING POTENTIAL PARAMETERS
        NRECL=NVAL*(2*NBNDT(IPAN)*(MIN(NBAS,MBAS)+1)+
     &  NBNDT(IPAN)**2)
        INQUIRE(FILE=SCNFILE(IGPTB,MY,47),EXIST=EXIST)
        IF(.NOT.EXIST)STATUS='NEW'
        IF(     EXIST)STATUS='OLD'
        OPEN(UNIT=47,FILE=SCNFILE(IGPTB,MY,47),STATUS=STATUS,
     &  ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
        INQUIRE(FILE=SCNFILE(IGPTB,MY,48),EXIST=EXIST)
        IF(.NOT.EXIST)STATUS='NEW'
        IF(     EXIST)STATUS='OLD'
        OPEN(UNIT=48,FILE=SCNFILE(IGPTB,MY,48),STATUS=STATUS,
     &  ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
        IF(KEYT.LE.0)THEN
	CLOSE(47)
	CLOSE(48)
	RETURN
	ENDIF
        DO IDIM=1,NBNDT(IPAN)                          !!! over idim
        DO JDIM=1,NBNDT(IPAN)                          !!! over jdim
        DRINT0Q(JDIM,IDIM)=(0.D0,0.D0)
        ENDDO                                          !!! over jdim
        DO IBAS=0,MIN(NBAS,MBAS)                       !!! over ibas
        DRFUN0(IDIM,IBAS)=(0.D0,0.D0)
        DRFUNQ(IDIM,IBAS)=(0.D0,0.D0)
        ENDDO                                          !!! over ibas
        ENDDO                                          !!! over idim
C STORE DATA
        DO 6000 IUPDN1=1,NSPIN                          !!! over spinors
        IF(NORBS.EQ.2)IORBS1=IUPDN1
        IF(NORBS.EQ.1)IORBS1=1
        DO 5000 IUPDN =1,NSPIN                          !!! over spinors
        IF(NORBS.EQ.2)IORBS=IUPDN
        IF(NORBS.EQ.1)IORBS=1
C SET LONGITUDINAL AND TRANSVERSE COMPONENTS
            IF(IUPDN1.EQ.1.AND.IUPDN.EQ.1)THEN
        IF(NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2)GOTO5000
        ISPIN=1
        ITRAN=0
        ELSEIF(IUPDN1.EQ.2.AND.IUPDN.EQ.2)THEN
        IF(NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2)GOTO5000
        ISPIN=2
        ITRAN=0
        ELSEIF(IUPDN1.EQ.1.AND.IUPDN.EQ.2)THEN
        IF(NORBS.EQ.1.AND.MY.NE.+1)GOTO5000
        ISPIN=0
        ITRAN=1
        ELSEIF(IUPDN1.EQ.2.AND.IUPDN.EQ.1)THEN
        IF(NORBS.EQ.1.AND.MY.NE.-1)GOTO5000
        ISPIN=0
        ITRAN=2
        ENDIF
        IREC=ISPIN
	IF(ISPIN.NE.0)
     &  WRITE(47,REC=IREC)((DRINT0Q(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,
     &  IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS)),
     &  ((DRFUNQ(IPAR1,IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,
     &  MIN(NBAS,MBAS))
        IREC=ITRAN
	IF(ITRAN.NE.0)
     &  WRITE(48,REC=IREC)((DRINT0Q(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,
     &  IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS)),
     &  ((DRFUNQ(IPAR1,IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,
     &  MIN(NBAS,MBAS))
5000    CONTINUE                                       !!! over spinors
6000    CONTINUE                                       !!! over spinors
	CLOSE(47)
	CLOSE(48)
        END
