	SUBROUTINE LMTBND(IPNT,IPAN)
*********************************************************
*  Subroutine prepares hamiltonian matrix and overlap   *
*  matrix,calculates eigenvalies and eigenvectors and   *
*  prepares wave functions                              *
*********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX),IS(NPAT)
     &    ,IND(LIMLMB,NPAT,NKAPMAX,NSPINMAX,NPANMAX),NKAP(NPANMAX)
     &    ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &    ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX) 
     &    ,APH(LIMLMB,NPAT,NKAPMAX),APJ(LIMLMT1,NPAT,NKAPMAX)
     &    ,SS(LIMLMT1,NPAT,LIMLMB,NPAT,NKAPMAX),CONV
     &    ,HMAT(NDIMMAX*NSPINMAX,NDIMMAX*NSPINMAX)
     &    ,OMAT(NDIMMAX*NSPINMAX,NDIMMAX*NSPINMAX)
	DIMENSION E(NDIMMAX*NSPINMAX),PNT(3,KMAX)
     &    ,EARR(NDIMMAX*NSPINMAX,KMAX,NPANMAX),SMT(NSORTMAX)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX),LOG
     &    ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
        COMMON /CONTROL/MAN,LMTO,NLR,NINT,NPF,MODE            !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM         !!! from init
	COMMON /POTCOM/ SWZ,SMT                               !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                     !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                 !!! from init
	COMMON /ENERGY/ EARR                                  !!! from lmtbnd
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                     !!! from init
	COMMON /MESH/   NPNT,PNT                              !!! from init
	COMMON /STORE2/ HMAT,OMAT                             !!! from lmtmat
	COMMON /DENS/   SS                                    !!! from strgnt
	COMMON /ORBS/   NORBS                                 !!! from init
	COMMON /SPIN/   NSPIN                                 !!! from init
	COMMON /INDX/   IND                                   !!! from lmtpar
	NDIM=NBNDT(IPAN)*NSPIN
C  HERMITIANNESS OF THE MATRICES
	DO IDIM1=1,NDIM
	DO IDIM=1,IDIM1
        TH=ABS(HMAT(IDIM1,IDIM)-CONJG(HMAT(IDIM,IDIM1)))
        IF(TH.GE.1.D-05)PRINT*,'HMAT-->',IDIM1,IDIM,TH
        TO=ABS(OMAT(IDIM1,IDIM)-CONJG(OMAT(IDIM,IDIM1)))
        IF(TO.GE.1.D-05)PRINT*,'OMAT-->',IDIM1,IDIM,TO
	ENDDO
	ENDDO
C  GENERALIZED EIGENVALUE PROBLEM
        CALL EIGEN1A(NDIM,HMAT,OMAT,E,NSPIN,NORBS,IERR)
C  EIGENVALUES
        DO IBNDS=1,NSPIN
        DO IBNDT=1,NBNDT(IPAN)
        IBAND=IBNDS+NSPIN*(IBNDT-1)
        EARR(IBAND,IPNT,IPAN)=E(IBAND)
        ENDDO
        ENDDO
        IREC=1+IPNT+NPNT*(IPAN-1)
        WRITE(10,REC=IREC)((E(IBNDS+NSPIN*(IBNDT-1)),
     &  IBNDS=1,NSPIN),IBNDT=1,NBNDT(IPAN))
C  WAVE COEFFICIENTS APH AND APJ 
	DO IORBS=1,NORBS            !!! over spinor components
	DO IBNDS=1,NSPIN            !!! over spin subbands
	IF(NORBS.EQ.1)ISPIN=IBNDS
	IF(NORBS.EQ.2)ISPIN=IORBS
	DO IBNDT=1,NBNDT(IPAN)      !!! over bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IKAP=1,NKAP(IPAN)        !!! over energies
	DO IATOM=1,NATOM            !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILST(ISORT)+1        !!! over l
	DO M=-L,L                   !!! over m
	LM=L*(L+1)+M+1
	CONV=(0.D0,0.D0)
	DO JATOM=1,NATOM            !!! over jatom
	DO L2=0,ILSB(IS(JATOM))     !!! over l2
	IF(LTPAN(L2,JATOM,IKAP,IPAN))THEN
	DO M2=-L2,L2                !!! over m2
	L2M2=L2*(L2+1)+M2+1
	JDIM=IND(L2M2,JATOM,IKAP,ISPIN,IPAN)
	CONV=CONV+SS(LM,IATOM,L2M2,JATOM,IKAP)*OMAT(JDIM,IBAND)
        ENDDO                       !!! over m2
	ENDIF
        ENDDO                       !!! over l2
        ENDDO                       !!! over jatom
	IF(L.LE.ILSB(ISORT))APH(LM,IATOM,IKAP)=(0.D0,0.D0)
	IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
	IDIM=IND(LM,IATOM,IKAP,ISPIN,IPAN)
	APH(LM,IATOM,IKAP)=OMAT(IDIM,IBAND)
	ENDIF
	APJ(LM,IATOM,IKAP)=CONV
        ENDDO                       !!! over m
        ENDDO                       !!! over l
        ENDDO                       !!! over iatom
        IF(MODE.NE.0.AND.MODE.NE.5)THEN ! store all bands
        NSHIFT=0
        DO JPAN=1,IPAN-1
        NSHIFT=NSHIFT+NKAP(JPAN)*NBNDT(JPAN)*
     &  NSPIN*NORBS*NPNT
	ENDDO
	IREC=1+IKAP+NKAP(IPAN)*(IBNDT-1)+
     &  NKAP(IPAN)*NBNDT(IPAN)*(IBNDS-1)+
     &  NKAP(IPAN)*NBNDT(IPAN)*NSPIN*(IORBS-1)+
     &  NKAP(IPAN)*NBNDT(IPAN)*NSPIN*NORBS*(IPNT-1)+NSHIFT
	WRITE(15,REC=IREC)
     &  ((APH(LM,IATOM,IKAP),LM=1,(ILSB(IS(IATOM))+1)**2),
     &  IATOM=1,NATOM),
     &  ((APJ(LM,IATOM,IKAP),LM=1,(ILST(IS(IATOM))+2)**2),
     &  IATOM=1,NATOM)
        ELSEIF(MODE.EQ.5.AND.(IBNDT.GE.NBNDE(IPAN).
     &  AND.IBNDT.LE.NBNDF(IPAN)))THEN !!! only for panel #1
        IF(IPAN.GT.1)STOP'<LMTBND>: RECORD FOR IPAN.GT.1 NOT ALLOWED'
	IREC=1+IKAP+NKAP(1)*(IBNDT-NBNDE(1))+
     &  NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*(IBNDS-1)+
     &  NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*(IORBS-1)+
     &  NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*NORBS*(IPNT-1)
	WRITE(15,REC=IREC)
     &  ((APH(LM,IATOM,IKAP),LM=1,(ILSB(IS(IATOM))+1)**2),
     &  IATOM=1,NATOM),
     &  ((APJ(LM,IATOM,IKAP),LM=1,(ILST(IS(IATOM))+2)**2),
     &  IATOM=1,NATOM)
	ENDIF
        ENDDO                       !!! over energies
        ENDDO                       !!! over bands
        ENDDO                       !!! over spin subbands
        ENDDO                       !!! over spinor components
	END
