	SUBROUTINE LMTMAT(IPNT,IPAN)
************************************************************
*  Subroutine  calculates Hamiltonian and overlap matrices *
*  Written by S.Yu.Savrasov in Max-Planck Institute,FRG    *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX),IS(NPAT)
     &    ,IND(LIMLMB,NPAT,NKAPMAX,NSPINMAX,NPANMAX),NKAP(NPANMAX)
     &    ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &    ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
	COMPLEX*16 HPARHH(LIMLMB,LIMLMB,NPAT),HPARJH(LIMLMT,LIMLMB,NPAT)
     &    ,HPARHJ(LIMLMB,LIMLMT,NPAT),HPARJJ(LIMLMT,LIMLMT,NPAT)
     &    ,OPARHH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,OPARJH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,OPARHJ(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,OPARJJ(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
     &    ,HMAT(NDIMMAX*NSPINMAX,NDIMMAX*NSPINMAX)
     &    ,OMAT(NDIMMAX*NSPINMAX,NDIMMAX*NSPINMAX)
     &    ,SS(LIMLMT1,NPAT,LIMLMB,NPAT,NKAPMAX),HHH,OOO
     &    ,SSDOT(LIMLMB1,NPAT,LIMLMB,NPAT,NKAPMAX)
     &    ,HSS(LIMLMT,NPAT),EK(NKAPMAX,NPANMAX)
     &    ,EKAP(NKAPMAX,NPANMAX)
        DIMENSION SMT(NSORTMAX)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	COMMON /CONTROL/MAN,LMTO,NLR,NOVR                      !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM          !!! from init
	COMMON /POTCOM/ SWZ,SMT                                !!! from init
	COMMON /DENS/   SS,SSDOT                               !!! from strgnt
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                      !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                  !!! from init
	COMMON /STORE1/ HPARHH,HPARJH,HPARHJ,HPARJJ            !!! from intpar
	COMMON /OVRPAR/ OPARHH,OPARJH,OPARHJ,OPARJJ            !!! from inopar
	COMMON /LATPAR/ PAR                                    !!! from init
	COMMON /STORE2/ HMAT,OMAT                              !!! from lmtmat
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                      !!! from init
	COMMON /INDX/   IND                                    !!! from lmtpar
	COMMON /SPIN/   NSPIN                                  !!! from init
	COMMON /WORD/   NVAL                                   !!! from nmtdata
	NDIM=NBNDT(IPAN)*NSPIN
C  DO GLOBALLY OVER SPINS, SET UP-UP, DN-DN HAMILTONIAN 
	DO 1000 ISPIN=1,NSPIN       !!! over spins
	DO IKAP1=1,NKAP(IPAN)       !!! over energy
	DO IKAP =1,NKAP(IPAN)       !!! over energy
	DO IATOM=1,NATOM            !!! read three-center parameter
	ISORT=IS(IATOM)
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &  NKAP(IPAN)**2*NATOM*(ISPIN-1)
	READ(13,REC=IREC)((HPARHH(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((HPARJH(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((HPARHJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((HPARJJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
        ENDDO         
C  SET HAMILTONIAN AND OVERLAP  MATRIX
	DO IATOM1=1,NATOM           !!! over iatom1
	ISORT1=IS(IATOM1)
	DO L1=0,ILSB(ISORT1)        !!! over l1
	IF(LTPAN(L1,IATOM1,IKAP1,IPAN))THEN
	DO M1=-L1,L1                !!! over m1
	L1M1=L1*(L1+1)+M1+1
	IDIM1=IND(L1M1,IATOM1,IKAP1,ISPIN,IPAN)
	DO KATOM=1,NATOM
	DO L3M3=1,(ILST(IS(KATOM))+1)**2
	HSS(L3M3,KATOM)=(0.D0,0.D0)
	DO L2M2=1,(ILST(IS(KATOM))+1)**2
	HSS(L3M3,KATOM)=HSS(L3M3,KATOM)+
     &  CONJG(SS(L2M2,KATOM,L1M1,IATOM1,IKAP1))*HPARJJ(L2M2,L3M3,KATOM)
        ENDDO         
        ENDDO         
        ENDDO         
	DO IATOM=1,NATOM            !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)          !!! over l
	IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
	DO M=-L,L                   !!! over m
	LM=L*(L+1)+M+1
	IDIM=IND(LM,IATOM,IKAP,ISPIN,IPAN)
	IF(IDIM1.GE.IDIM)THEN
	HHH= (0.D0,0.D0)
	OOO= (0.D0,0.D0)
C   ONE-CENTER TERM :
	IF(IATOM1.EQ.IATOM)THEN
	IF(L1M1.EQ.LM)
     &  OOO=OOO+OPARHH(IKAP1,IKAP,L,ISORT,ISPIN)
	HHH=HHH+HPARHH(L1M1,LM,IATOM)
	ENDIF
C   TWO-CENTER TERM :
	DO L2M2=1,(ILST(ISORT)+1)**2      !!! over l2m2
	HHH=HHH-HPARJH(L2M2,LM,IATOM)*
     &  CONJG(SS(L2M2,IATOM,L1M1,IATOM1,IKAP1))
        ENDDO                             !!! over l2m2
	OOO=OOO-OPARJH(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  CONJG(SS(LM,IATOM,L1M1,IATOM1,IKAP1))
	DO L2M2=1,(ILST(ISORT1)+1)**2     !!! over l2m2
	HHH=HHH-HPARHJ(L1M1,L2M2,IATOM1)*
     &  SS(L2M2,IATOM1,LM,IATOM,IKAP)
        ENDDO                             !!! over l2m2
	OOO=OOO-OPARHJ(IKAP1,IKAP,L1,ISORT1,ISPIN)*
     &  SS(L1M1,IATOM1,LM,IATOM,IKAP)
C  ADD SSDOT MATRIX IN CASE EQUAL ENERGIES
	IF(EKAP(IKAP,IPAN).EQ.CONJG(EKAP(IKAP1,IPAN)))THEN
	IF(NOVR.EQ.0)
     &  OOO=OOO-CONJG(SSDOT(LM,IATOM,L1M1,IATOM1,IKAP))
	HHH=HHH-CONJG(SSDOT(LM,IATOM,L1M1,IATOM1,IKAP))*
     &  EKAP(IKAP,IPAN)
	ENDIF
C   THREE-CENTER TERM :
	DO KATOM=1,NATOM                  !!! over katom
	KSORT=IS(KATOM)
	DO L2=0,ILST(KSORT)               !!! over l2
	DO M2=-L2,L2                      !!! over m2
	L2M2=L2*(L2+1)+M2+1
	HHH=HHH+HSS(L2M2,KATOM)*SS(L2M2,KATOM,LM,IATOM,IKAP)
	OOO=OOO+CONJG(SS(L2M2,KATOM,L1M1,IATOM1,IKAP1))*
     &  OPARJJ(IKAP1,IKAP,L2,KSORT,ISPIN)*
     &  SS(L2M2,KATOM,LM,IATOM,IKAP)
        ENDDO                             !!! over m2
        ENDDO                             !!! over l2
        ENDDO                             !!! over katom
C   SET ZEROES WHERE NECESSARY
	HRE= DREAL(HHH)  ! real part of the hamiltonian matrix
	HIM= DIMAG(HHH)  ! imaginary part of the hamiltonian matrix
	ORE= DREAL(OOO)  ! real part of the overlap matrix
	OIM= DIMAG(OOO)  ! imaginary part of the overlap matrix
C       IF(ABS(HRE).LE.1.D-10)HRE=0.D0
C       IF(ABS(HIM).LE.1.D-10)HIM=0.D0
C       IF(ABS(ORE).LE.1.D-10)ORE=0.D0   ! not necessary now !
C       IF(ABS(OIM).LE.1.D-10)OIM=0.D0
	IF(IDIM1.EQ.IDIM)HIM=0.D0
	IF(IDIM1.EQ.IDIM)OIM=0.D0
C   SET HAMILTONIAN AND OVERLAP MATRICES
        HMAT(IDIM1,IDIM)=HMAT(IDIM1,IDIM)+DCMPLX(HRE,+HIM)
        OMAT(IDIM1,IDIM)=OMAT(IDIM1,IDIM)+DCMPLX(ORE,+OIM)
        HMAT(IDIM,IDIM1)=DCONJG(HMAT(IDIM1,IDIM))
        OMAT(IDIM,IDIM1)=DCONJG(OMAT(IDIM1,IDIM))
	ENDIF
        ENDDO                             !!! over m
	ENDIF
        ENDDO                             !!! over l
        ENDDO                             !!! over iatom
        ENDDO                             !!! over m1
	ENDIF
        ENDDO                             !!! over l1
        ENDDO                             !!! over iatom1
        ENDDO                             !!! over energy
        ENDDO                             !!! over energy
1000    CONTINUE                          !!! over spins
	END
