	SUBROUTINE MIXDPS(IQPNT,ITER,EXIT)
******************************************************
*  Admixture of the induced charge density in the    *
*  self-consistent cycle (pseudopart)                *
******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),NQDIV(3),NITER(0:NENVMAX,-1:2)
     &   ,KEY(0:NENVMAX,-1:2),KSP(0:NENVMAX,-1:2)
     &   ,LBROY(0:NENVMAX,-1:2),IBROY(0:NENVMAX,-1:2)
     &   ,INDGPTB(0:NENVMAX),INGPTBR(NOPRMAX,0:NENVMAX)
     &   ,INDGCON(0:NENVMAX,0:NENVMAX)
	DIMENSION SMT(NSORTMAX),QPNT(3),QPNT0(3),EPS(0:NENVMAX,-1:2)
     &   ,GPLW(3,0:NPLWMAX),ORTH(2:3),RBAS(3,3),GBAS(3,3)
     &   ,ADMOPT(0:NENVMAX,-1:2),ADSPIN(0:NENVMAX,-1:2)
     &   ,ADMIX1(0:NENVMAX,-1:2),ADMIN (0:NENVMAX,-1:2)
     &   ,ADMAX (0:NENVMAX,-1:2),ADMIXB(0:NENVMAX,-1:2)
     &   ,ADMSPN(0:NENVMAX,-1:2),ASMIN (0:NENVMAX,-1:2)
     &   ,ASMAX (0:NENVMAX,-1:2),ADMIXH(0:NENVMAX,-1:2)
	DIMENSION CONVDRO(0:NENVMAX,-1:2),CONVDMO(0:NENVMAX,-1:2)
     &   ,CONVDPS(0:NENVMAX,-1:2),CONVDMS(-1:1,0:NENVMAX,-1:2)
     &   ,CONVDMG(-1:1,0:NENVMAX,-1:2),GPTB(3,0:NENVMAX)
        COMPLEX*16 
     &    DRHOPS(0:NPLWMAX,NSPINMAX),TRHOPS(0:NPLWMAX,NSPINMAX)
     &   ,DMAGPS(0:NPLWMAX,NSPINMAX),TMAGPS(0:NPLWMAX,NSPINMAX)
     &   ,DRHOOUT,DRHOINP,DRHONEW,DMAGOUT,DMAGINP,DMAGNEW,CNUM0P
	CHARACTER TXTEL(NSORTMAX)*10,POL(-1:2)*1
	LOGICAL EXIT
C Controls:
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE         !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from init
	COMMON /SPIN/   NSPIN                                !!! from init
C Inputs:
        COMMON /LATPAR/ PAR,ORTH,OMEGAC                      !!! from init
	COMMON /POTCOM/ SWZ,SMT                              !!! from init
        COMMON /MAGCOM/ ITERMAX,NITER,EPS,CONVDRO,CONVDMO,CONVDMG
	COMMON /QMESH/  NQPNT,QPNT,NUMQ,NQDIV,KEYQ           !!! from init
        COMMON /PTBCOM/ NGSHL,NGPTB,GPTB,INDGPTB,INGPTBR,INDGCON!from plwptb
C Mixings:
        COMMON /MIXDRHO/ADMIX1,ADMIN,ADMAX,KEY,ADMOPT        !!! from mixdrho
        COMMON /MIXDMAG/ADMSPN,ASMIN,ASMAX,KSP,ADSPIN        !!! from mixdrho
        COMMON /MIXDBRD/LBROY,IBROY,ADMIXB,ADMIXH            !!! from mixdrob
C Plane waves:
	COMMON /PLWMESH/NPLW,GPLW                            !!! from plwmsh
C Density:
        COMMON /DPSRHO/ DRHOPS,DMAGPS                        !!! from dpsfiles
        COMMON /STORE1/ TRHOPS,TMAGPS                        !!! from dpsfiles
C Outputs:
	COMMON /WORD/   NVAL                                 !!! from block
	COMMON /TXTEL/  TXTEL                                !!! from init
	COMMON /UNIT/   IUN,IUT,IUR                          !!! from init
	DATA PI/3.141592653589793D0/,POL/'m','z','p','v'/
        IF((MODE.EQ.4.OR.MODE.EQ.5).AND.ITER.GE.1)RETURN
C *** DO GLOBALLY OEVR DISPLACEMENTS AND POLARIZATIONS
        DO 2000 MY=-1,2                        !!! over polarizations
        DO 1000 IGPTB=0,NGPTB                  !!! over g-vectors
        IF(NITER(IGPTB,MY).EQ.0)GOTO1000
C ITER<1, NOTHING IS KNOWN AT THE MOMENT
        IF(ITER.LT.1.AND.MODE.EQ.1)THEN
        CALL DPSFILES(IGPTB,MY,IQPNT,34,'I')
        CALL DPSFILES(IGPTB,MY,IQPNT,35,'I')
C ITER<1, EVERYTHING IS KNOWN
        ELSEIF(ITER.LT.1.AND.MODE.GT.1)THEN
        CALL DPSFILES(IGPTB,MY,IQPNT,35,'I')
        CALL DPSFILES(IGPTB,MY,IQPNT,34,'R')
        CALL DPSFILES(IGPTB,MY,IQPNT,35,'W')
        ENDIF
        IF(ITER.LT.1)GOTO1000
C CALCULATE CHARGE DENSITY DIFFERENCE BETWEEN TWO ITERATIONS
        CALL DPSFILES(IGPTB,MY,IQPNT,34,'R')
	DO ISPIN=1,NSPIN
	ITRAN=ISPIN
	DO IPLW=0,NPLW
	TRHOPS(IPLW,ISPIN)=DRHOPS(IPLW,ISPIN)
	TMAGPS(IPLW,ITRAN)=DMAGPS(IPLW,ITRAN)
	ENDDO
	ENDDO
        CALL DPSFILES(IGPTB,MY,IQPNT,35,'R')
        CONVDPS(IGPTB,MY)=0.D0
        CONVDMS(-1,IGPTB,MY)=0.D0
        CONVDMS( 0,IGPTB,MY)=0.D0
        CONVDMS(+1,IGPTB,MY)=0.D0
        DO IPLW=0,NPLW                       !!! over plane waves
C DENSITY CONVERGENCY
        DRHOOUT=(DRHOPS(IPLW,1)+DRHOPS(IPLW,NSPIN))/
     &  2.D0*DBLE(NSPIN)
        DRHOINP=(TRHOPS(IPLW,1)+TRHOPS(IPLW,NSPIN))/
     &  2.D0*DBLE(NSPIN)
        CONVDPS(IGPTB,MY)=CONVDPS(IGPTB,MY)+
     &  DCONJG(DRHOOUT)*DRHOOUT+DCONJG(DRHOINP)*DRHOINP-
     &  DCONJG(DRHOOUT)*DRHOINP-DCONJG(DRHOINP)*DRHOOUT
C MAGNETIZATION CONVERGENCY, Z-POLARIZATION
        DMAGOUT=DRHOPS(IPLW,1)-DRHOPS(IPLW,NSPIN)
        DMAGINP=TRHOPS(IPLW,1)-TRHOPS(IPLW,NSPIN)
        CONVDMS(0,IGPTB,MY)=CONVDMS(0,IGPTB,MY)+
     &  DCONJG(DMAGOUT)*DMAGOUT+DCONJG(DMAGINP)*DMAGINP-
     &  DCONJG(DMAGOUT)*DMAGINP-DCONJG(DMAGINP)*DMAGOUT
C MAGNETIZATION CONVERGENCY, "-" POLARIZATION
        DMAGOUT=DMAGPS(IPLW,1)
        DMAGINP=TMAGPS(IPLW,1)
        CONVDMS(-1,IGPTB,MY)=CONVDMS(-1,IGPTB,MY)+
     &  DCONJG(DMAGOUT)*DMAGOUT+DCONJG(DMAGINP)*DMAGINP-
     &  DCONJG(DMAGOUT)*DMAGINP-DCONJG(DMAGINP)*DMAGOUT
C MAGNETIZATION CONVERGENCY, "+" POLARIZATION
        DMAGOUT=DMAGPS(IPLW,NSPIN)
        DMAGINP=TMAGPS(IPLW,NSPIN)
        CONVDMS(+1,IGPTB,MY)=CONVDMS(+1,IGPTB,MY)+
     &  DCONJG(DMAGOUT)*DMAGOUT+DCONJG(DMAGINP)*DMAGINP-
     &  DCONJG(DMAGOUT)*DMAGINP-DCONJG(DMAGINP)*DMAGOUT
        ENDDO                                !!! over plane waves
1000	CONTINUE                             !!! over g-vectors
2000	CONTINUE                             !!! over polarizations
	IF(ITER.LT.1)RETURN
C ADMIX NEW AND OLD INDUCED CHARGE DENSITIES : [drho/dt]{inp}(i+1)
        DO 4000 MY=-1,2                      !!! over polarizations
        DO 3000 IGPTB=0,NGPTB                !!! over g-vectors
        IF(NITER(IGPTB,MY).EQ.0)GOTO3000
        CALL DPSFILES(IGPTB,MY,IQPNT,34,'R')
	DO ISPIN=1,NSPIN
	ITRAN=ISPIN
	DO IPLW=0,NPLW
	TRHOPS(IPLW,ISPIN)=DRHOPS(IPLW,ISPIN)
	TMAGPS(IPLW,ITRAN)=DMAGPS(IPLW,ITRAN)
	ENDDO
	ENDDO
        CALL DPSFILES(IGPTB,MY,IQPNT,35,'R')
	IF(LBROY(IGPTB,MY).LT.0)THEN
        DO IPLW=0,NPLW                       !!! over plane waves
C TOTAL INDUCED DENSITY
        DRHOOUT=(DRHOPS(IPLW,1)+DRHOPS(IPLW,NSPIN))/
     &  2.D0*DBLE(NSPIN)
        DRHOINP=(TRHOPS(IPLW,1)+TRHOPS(IPLW,NSPIN))
     &  /2.D0*DBLE(NSPIN)
        DRHONEW=ADMOPT(IGPTB,MY)*DRHOOUT+
     &  (1.D0-ADMOPT(IGPTB,MY))*DRHOINP
C INDUCED MAGNETIZATION, Z POLARIZATION
        DMAGOUT=DRHOPS(IPLW,1)-DRHOPS(IPLW,NSPIN)
        DMAGINP=TRHOPS(IPLW,1)-TRHOPS(IPLW,NSPIN)
        DMAGNEW=ADSPIN(IGPTB,MY)*DMAGOUT+
     &  (1.D0-ADSPIN(IGPTB,MY))*DMAGINP
        DRHOPS(IPLW,1    )=(DRHONEW+DMAGNEW)/DBLE(NSPIN)
        DRHOPS(IPLW,NSPIN)=(DRHONEW-DMAGNEW)/DBLE(NSPIN)
        DO ITRAN=1,NSPIN
C INDUCED MAGNETIZATION, "-/+" POLARIZATION
        DMAGOUT=DMAGPS(IPLW,ITRAN)
        DMAGINP=TMAGPS(IPLW,ITRAN)
        DMAGNEW=ADSPIN(IGPTB,MY)*DMAGOUT+
     &  (1.D0-ADSPIN(IGPTB,MY))*DMAGINP
        DMAGPS(IPLW,ITRAN)=DMAGNEW
        ENDDO
        ENDDO                                !!! over plane waves
	ENDIF
        CALL DPSFILES(IGPTB,MY,IQPNT,34,'W')
        CALL DPSFILES(IGPTB,MY,IQPNT,35,'W')
3000	CONTINUE                             !!! over g-vectors
4000	CONTINUE                             !!! over polarizations
C  PRINT INFORMATION
        WRITE(IUN,1010)
        IF(IUN.NE.IUT)WRITE(IUT,1010)
        DO 6000 MY=-1,2                      !!! over polarizations
        DO 5000 IGPTB=0,NGPTB                !!! over g-vectors
        WRITE(IUN,1020)POL(MY)
        WRITE(IUN,1021)IGPTB,GPTB(1,IGPTB),GPTB(2,IGPTB),GPTB(3,IGPTB)
        IF(NITER(IGPTB,MY).EQ.0)WRITE(IUN,1090)
        IF(NITER(IGPTB,MY).EQ.0.AND.IUN.NE.IUT)WRITE(IUT,1090)
	IF(NITER(IGPTB,MY).EQ.0)GOTO5000
        IF(LBROY(IGPTB,MY).LT.0)
     &  WRITE(IUN,1030)ADMOPT(IGPTB,MY),ADMIN(IGPTB,MY),
     &  ADMAX(IGPTB,MY),ADSPIN(IGPTB,MY)
        IF(LBROY(IGPTB,MY).GE.0)
     &  WRITE(IUN,1040)ADMIXB(IGPTB,MY),ADMOPT(IGPTB,MY)
        WRITE(IUN,1050)
     &  SQRT(CONVDRO(   IGPTB,MY)),SQRT(CONVDPS(   IGPTB,MY))
        WRITE(IUN,1060)
     &  SQRT(CONVDMG( 0,IGPTB,MY)),SQRT(CONVDMS( 0,IGPTB,MY))
        WRITE(IUN,1070)
     &  SQRT(CONVDMG(-1,IGPTB,MY)),SQRT(CONVDMS(-1,IGPTB,MY))
        WRITE(IUN,1080)
     &  SQRT(CONVDMG(+1,IGPTB,MY)),SQRT(CONVDMS(+1,IGPTB,MY))
        IF(IUN.EQ.IUT)GOTO5000
        WRITE(IUT,1020)POL(MY)
        WRITE(IUT,1021)IGPTB,GPTB(1,IGPTB),GPTB(2,IGPTB),GPTB(3,IGPTB)
        IF(LBROY(IGPTB,MY).LT.0)
     &  WRITE(IUT,1030)ADMOPT(IGPTB,MY),ADMIN(IGPTB,MY),
     &  ADMAX(IGPTB,MY),ADSPIN(IGPTB,MY)
        IF(LBROY(IGPTB,MY).GE.0)
     &  WRITE(IUT,1040)ADMIXB(IGPTB,MY),ADMOPT(IGPTB,MY)
        WRITE(IUT,1050)
     &  SQRT(CONVDRO(   IGPTB,MY)),SQRT(CONVDPS(   IGPTB,MY))
        WRITE(IUT,1060)
     &  SQRT(CONVDMG( 0,IGPTB,MY)),SQRT(CONVDMS( 0,IGPTB,MY))
        WRITE(IUT,1070)
     &  SQRT(CONVDMG(-1,IGPTB,MY)),SQRT(CONVDMS(-1,IGPTB,MY))
        WRITE(IUT,1080)
     &  SQRT(CONVDMG(+1,IGPTB,MY)),SQRT(CONVDMS(+1,IGPTB,MY))
5000	CONTINUE                            !!! over polarizations
6000	CONTINUE                            !!! over polarizations
C CHECK FOR CONVERGENCY
	DO MY=-1,2
	DO IGPTB=0,NGPTB
	IF(NITER(IGPTB,MY).NE.0)THEN
        EXDRHO=SQRT(CONVDRO(IGPTB,MY))
        EXDMOM=SQRT(CONVDMO(IGPTB,MY))
        IF(EXDRHO.LE.EPS(IGPTB,MY).AND.EXDMOM.LE.EPS(IGPTB,MY))
     &  NITER(IGPTB,MY)=0
	ENDIF
	ENDDO
	ENDDO
C CHECK FOR CONVERGENCY
        DO MY=-1,2
        DO IGPTB=0,NGPTB
        IF(NITER(IGPTB,MY).NE.0)THEN
        DO IGPTB1=0,NGPTB
        IF(INDGCON(IGPTB,IGPTB1).EQ.1)THEN
        IF(NITER(IGPTB1,MY).NE.NITER(IGPTB,MY))THEN
        MAXITER=MAX(NITER(IGPTB1,MY),NITER(IGPTB,MY))
        NITER(IGPTB, MY)=MAXITER
        NITER(IGPTB1,MY)=MAXITER
	ENDIF
        ENDIF
        ENDDO
        ENDIF
        ENDDO
        ENDDO
C CHECK FOR EXITING
        NIT=0
        DO MY=-1,2
	DO IGPTB=0,NGPTB
        NIT=NIT+NITER(IGPTB,MY)
        ENDDO
        ENDDO
        IF(NIT.NE.0)EXIT=.FALSE.
        IF(NIT.EQ.0)EXIT=.TRUE.
C SET MODE=2
        IF(ITER.EQ.1)MODE=2 
1010    FORMAT(1X,'***** Results from the linear-mixing subroutines ->')
1020    FORMAT(1X,'MAGNETIC FIELD POLARIZATION  "',A1,'" ')
1021    FORMAT(1X,'G',I2,'=(',G12.5,',',G12.5,',',G12.5,')')
1030    FORMAT(1X,'Opt,min,max,spn mix =',4(G12.5,1X))
1040    FORMAT(1X,'Broyden is on! bmix =',2(G12.5,1X))
1050    FORMAT(1X,'Density Convergence =',2(G12.5,1X))
1060    FORMAT(1X,'Z-magn. Convergence =',2(G12.5,1X))
1070    FORMAT(1X,'M-magn. Convergence =',2(G12.5,1X))
1080    FORMAT(1X,'P-magn. Convergence =',2(G12.5,1X))
1090	FORMAT(1X,'Self-Consistensy either done or not performed.')
	END
