	SUBROUTINE PRINLRT
**********************************************************
*  Prints LRTFILE                                        *
**********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX)
        DIMENSION SMT(NSORTMAX),ORTH(2:3)
        COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
        CHARACTER*60 INIFILE,SC0FILE,STRFILE,SCRFILE(100)
     &    ,HUBFILE,HOPFILE,OPTFILE,ENRFILE,PNTFILE
     &    ,CONFILE,FTRFILE,KOVFILE,PSIFILE,TMPFILE
     &    ,BNDFILE,POTFILE,FATFILE,DOSFILE,SCFFILE
     &    ,OUTFILE
	CHARACTER*60 SCPFILE(NENVMAX,100),PLZFILE(NENVMAX)
     &    ,PLSFILE(NENVMAX),DSFFILE,PHNFILE,TMLFILE,WGTFILE(10)
        CHARACTER*60 SCNFILE(0:NENVMAX,-1:2,100)
     &   ,DROFILE(0:NENVMAX,-1:2),DPSFILE(0:NENVMAX,-1:2)
     &   ,DSVFILE(0:NENVMAX,-1:2),DPVFILE(0:NENVMAX,-1:2)
        CHARACTER TXTEL(NSORTMAX)*10
C Controls:
        COMMON /CONTROL/LIFT,LMTO,NLR,NINT,NPF,MODE         !!! from init
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from readini
        COMMON /PLZCOM/ NPLZ,LPLZ,IPLZ                      !!! from readlrt
        COMMON /STNCOM/ NSTN,LSTN,ISTN                      !!! from readlrt
        COMMON /DLFCOM/ NDLF,LDLF,IDLF                      !!! from readlrt
        COMMON /WHICOM/ NWHI,LWHI,IWHI                      !!! from readlrt
        COMMON /EXCH/   IXC                                 !!! from readini
C Additional inputs:
        COMMON /INP0/   INIFILE,SC0FILE,STRFILE             !!! from init
        COMMON /INP1/   ICHUB,ICHOP,ICOPT,ICENR,ICPNT       !!! from readini
        COMMON /INP2/   HUBFILE,HOPFILE,OPTFILE,ENRFILE,PNTFILE
C Frequency:
	COMMON /FREQU/  OMGR                                !!! from init
C Outputs:
        COMMON /OUT0/   SCRFILE                             !!! from readini
        COMMON /OUT1/   ICCON,ICFTR,ICKOV,ICPSI,ICTMP,ICBND !!! from readini
     &                 ,ICPOT,ICFAT,ICDOS,ICSCF,ICOUT
        COMMON /OUT2/   CONFILE,FTRFILE,KOVFILE,PSIFILE,TMPFILE
     &                 ,BNDFILE,POTFILE,FATFILE,DOSFILE,SCFFILE
     &                 ,OUTFILE
        COMMON /OUT0PH/ SCNFILE,DROFILE,DSVFILE,DPSFILE,DPVFILE! from readlrt
        COMMON /OUT1PH/ ICDSF,ICDRO,ICPHN,ICTML,ICDSV,ICWGT !!! from readlrt
        COMMON /OUT2PH/ DSFFILE,PHNFILE,TMLFILE,WGTFILE     !!! from readlrt
        COMMON /OUT4PH/ SCPFILE,PLZFILE,PLSFILE             !!! from readlrt
        COMMON /TXTEL/  TXTEL                               !!! from readini
        COMMON /UNIT/   IUN                                 !!! from readini
C  PRINT HEAD
        WRITE(IUN,1000)
1000    FORMAT(/'<<<--- INPUT LRTFILE READ --->>>'/)
C  PRINT TITLE
	WRITE(IUN,1010)
	WRITE(IUN,1020)
1010	FORMAT(1X,'   SET-UP DATA FOR LINEAR RESPONSE CALCULATIONS')
1020    FORMAT(1X,'---------------------------------------------------')
C  PRINT CONTROL PARAMETERS
	WRITE(IUN,1100)
1100	FORMAT(1X,'<GENERAL SETTINGS>    :')
	IF(LIFT.LT.4)WRITE(IUN,1110)
	IF(LIFT.EQ.4)WRITE(IUN,1111)
1110	FORMAT(1X,'lift  < 4',15X,'- Self-consistency is off')
1111	FORMAT(1X,'lift  = 4',15X,'- Self-consistency is on ')
        IF(LPLZ.EQ.0)WRITE(IUN,1120)
        IF(LPLZ.NE.0)WRITE(IUN,1121)LPLZ
1120    FORMAT(1X,'lplz  = 0',15X,'- Polarizability   is off')
1121    FORMAT(1X,'lplz  = ',I1,15X,'- Polarizability   is on ') 
        IF(LSTN.EQ.0)WRITE(IUN,1130)
        IF(LSTN.EQ.1)WRITE(IUN,1131)
1130    FORMAT(1X,'lstn  = 0',15X,'- Stoner matrix    is off')
1131    FORMAT(1X,'lstn  = 1',15X,'- Stoner matrix    is on ') 
        IF(LDLF.EQ.2)WRITE(IUN,1140)
        IF(LDLF.EQ.1)WRITE(IUN,1141)
1140    FORMAT(1X,'ldlf  = 2',15X,'- Changes in phi  are on ')
1141    FORMAT(1X,'ldlf  = 1',15X,'- Changes in phi  are off') 
        IF(NPFR.EQ.0)WRITE(IUN,1150)
        IF(NPFR.EQ.1)WRITE(IUN,1151)
        IF(NPFR.EQ.2)WRITE(IUN,1152)
1150    FORMAT(1X,'ldyn  = 0',15X,'- No dynamical matrix    ')
1151    FORMAT(1X,'ldyn  = 1',15X,'- Full evaluation of DMAT') 
1152    FORMAT(1X,'ldyn  = 2',15X,'- Fast evaluation of DMAT') 
	IF(MODE.EQ.0)WRITE(IUN,1200) 
	IF(MODE.EQ.1)WRITE(IUN,1201) 
	IF(MODE.EQ.2)WRITE(IUN,1202) 
	IF(MODE.EQ.3)WRITE(IUN,1203) 
	IF(MODE.EQ.4)WRITE(IUN,1204) 
	IF(MODE.EQ.5)WRITE(IUN,1205) 
1200	FORMAT(1X,'mode  = 0',15X,'- Preparational regime')
1201	FORMAT(1X,'mode  = 1',15X,'- Restart calcuation is off')
1202	FORMAT(1X,'mode  = 2',15X,'- Full Restart is on')
1203	FORMAT(1X,'mode  = 3',15X,'- Restart with update is on')
1204	FORMAT(1X,'mode  = 4',15X,'- Susceptibility calculation')
1205	FORMAT(1X,'mode  = 5',15X,'- Imaginary part calculation')
C  PRINT FILE SETTINGS
	WRITE(IUN,1300)
1300	FORMAT(1X,'<DEFAULT FILE SETTINGS>    :')
	NB=INDEX(WGTFILE(LWHI),' ')
	IF(ICWGT.EQ.0)WRITE(IUN,1320)
	IF(ICWGT.EQ.1)WRITE(IUN,1321)WGTFILE(LWHI)(:NB-1)
	IF(ICWGT.EQ.2)WRITE(IUN,1322)WGTFILE(LWHI)(:NB-1)
1320	FORMAT(1X,'iwgt  = 0',15X,'- no storage of tetra.weights')
1321	FORMAT(1X,'iwgt  = 1',15X,'- save tetra. weights in   ',A)
1322	FORMAT(1X,'iwgt  = 2',15X,'- read tetra. weights from ',A)
	NB=INDEX(PHNFILE,' ')
	IF(ICPHN.EQ.0)WRITE(IUN,1330)
	IF(ICPHN.EQ.1)WRITE(IUN,1331)PHNFILE(:NB-1)
	IF(ICPHN.EQ.2)WRITE(IUN,1332)PHNFILE(:NB-1)
1330	FORMAT(1X,'iphn  = 0',15X,'- no storage of phonon modes')
1331	FORMAT(1X,'iphn  = 1',15X,'- save phonon  modes  in   ',A)
1332	FORMAT(1X,'iphn  = 2',15X,'- read phonon  modes  from ',A)
	NB=INDEX(DSVFILE(0,-1),' ')
	IF(ICDSV.EQ.0)WRITE(IUN,1340)
	IF(ICDSV.EQ.1)WRITE(IUN,1341)DSVFILE(0,-1)(:NB-1)
	IF(ICDSV.EQ.2)WRITE(IUN,1342)DSVFILE(0,-1)(:NB-1)
	NB=INDEX(DPVFILE(0,-1),' ')
	IF(ICDSV.EQ.1)WRITE(IUN,1343)DPVFILE(0,-1)(:NB-1)
	IF(ICDSV.EQ.2)WRITE(IUN,1344)DPVFILE(0,-1)(:NB-1)
1340	FORMAT(1X,'idsv  = 0',15X,'- no storage of ind.potential')
1341	FORMAT(1X,'idsv  = 1',15X,'- save ind.potential  in   ',A)
1342	FORMAT(1X,'idsv  = 2',15X,'- read ind.potential  from ',A)
1343	FORMAT(1X,'idsv  = 1',15X,'- save psd.potential  in   ',A)
1344	FORMAT(1X,'idsv  = 2',15X,'- read psd.potential  from ',A)
        IF(LPLZ.NE.0)THEN
	ICPLZ=IPLZ
        NB=INDEX(PLZFILE(1),' ')
        IF(ICPLZ.EQ.0)WRITE(IUN,1345)
        IF(ICPLZ.EQ.1)WRITE(IUN,1346)PLZFILE(1)(:NB-1)
        IF(ICPLZ.EQ.2)WRITE(IUN,1347)PLZFILE(1)(:NB-1)
1345    FORMAT(1X,'iplz  = 0',15X,'- no storage of polarizability')
1346    FORMAT(1X,'iplz  = 1',15X,'- save polarizability in   ',A)
1347    FORMAT(1X,'iplz  = 2',15X,'- read polarizability from ',A)
        NB=INDEX(PLSFILE(1),' ')
        IF(ICPLZ.EQ.1)WRITE(IUN,1348)PLSFILE(1)(:NB-1)
        IF(ICPLZ.EQ.2)WRITE(IUN,1349)PLSFILE(1)(:NB-1)
1348    FORMAT(1X,'iplz  = 1',15X,'- also save plw.part  in   ',A)
1349    FORMAT(1X,'iplz  = 2',15X,'- also read plw.part  from ',A)
        ENDIF
	NB=INDEX(DROFILE(0,-1),' ')
	IF(ICDRO.EQ.0)WRITE(IUN,1350)
	IF(ICDRO.EQ.1)WRITE(IUN,1351)DROFILE(0,-1)(:NB-1)
	IF(ICDRO.EQ.2)WRITE(IUN,1352)DROFILE(0,-1)(:NB-1)
	NB=INDEX(DPSFILE(0,-1),' ')
	IF(ICDRO.EQ.1)WRITE(IUN,1353)DPSFILE(0,-1)(:NB-1)
	IF(ICDRO.EQ.2)WRITE(IUN,1354)DPSFILE(0,-1)(:NB-1)
1350	FORMAT(1X,'idro  = 0',15X,'- no storage of ind. density')
1351	FORMAT(1X,'idro  = 1',15X,'- update ind.density  in   ',A)
1352	FORMAT(1X,'idro  = 1',15X,'- update ind.density  in   ',A)
1353	FORMAT(1X,'idro  = 1',15X,'- update psd.density  in   ',A)
1354	FORMAT(1X,'idro  = 1',15X,'- update psd.density  in   ',A)
	NB=INDEX(OUTFILE,' ')
	IF(ICOUT.EQ.0)WRITE(IUN,1360)
	IF(ICOUT.EQ.1)WRITE(IUN,1361)OUTFILE(:NB-1)
	IF(ICOUT.EQ.2)WRITE(IUN,1362)OUTFILE(:NB-1)
	IF(ICOUT.GT.2)WRITE(IUN,1363)
1360	FORMAT(1X,'iout  = 0',15X,'- no output data file')
1361	FORMAT(1X,'iout  = 1',15X,'- save current output in   ',A)
1362	FORMAT(1X,'iout  = 2',15X,'- save current output in   ',A)
1363	FORMAT(1X,'iout  > 2',15X,'- print current output')
	END
