	   SUBROUTINE DMULTRHO(IGPTB,MY,IQPNT)
**************************************************************
*  Calculates induced multipoles.                            *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT),NRAD(NSORTMAX)
	DIMENSION ZCOR(NSORTMAX),H(NSORTMAX),R(0:NRADMAX,NSORTMAX)
     &    ,ROCOR(0:NRADMAX,NSORTMAX,NSPINMAX),BET(0:LMAXV,NSORTMAX)
     &    ,RL(0:NRADMAX,0:LMAXV,NSORTMAX),SMT(NSORTMAX),Z(NSORTMAX)
     &    ,WEIGHT(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &    ,BES(0:LMAXV+1),BESD(0:LMAXV+1),TAU(3,NPAT),GPLW(3,0:NPLWMAX)
     &    ,ORTH(2:3),BT(0:LMAXV+1),QPNT(3)
	COMPLEX*16 EXPT,DMAGPS(0:NPLWMAX,NSPINMAX),WORK2(0:NRADMAX)
     &    ,DRHOPS(0:NPLWMAX,NSPINMAX),DRHOPS1(0:NPLWMAX,NSPINMAX) 
     &    ,DRHO(0:NRADMAX,LMMAXV,NPAT,NSPINMAX),RHAN(0:LMAXV+1)
     &    ,DMAG(0:NRADMAX,LMMAXV,NPAT,NSPINMAX),WORK1(0:NRADMAX)
     &    ,DELMRO (LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2),YLM(LMMAXV)
     &    ,DPSMOM1(LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &    ,DPSMOM (LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &    ,DELMAD (LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &    ,DELMAG (LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
	CHARACTER TXTEL(NSORTMAX)*10
	LOGICAL SYM(LMMAXV,NPAT)
C Controls:
        COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE        !!! from readini
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from readini
	COMMON /SPIN/   NSPIN                               !!! from readini
	COMMON /ORBS/   NORBS                               !!! from qvector
C Inputs:
	COMMON /POTCOM/ SWZ,SMT                             !!! from readini
	COMMON /BASIS/  TAU                                 !!! from readstr
	COMMON /MULTRO/ Z,ZCOR                              !!! from multrho
	COMMON /SYMMLM/ SYM,LMSYM                           !!! from symlm
	COMMON /QMESH/  NQPNT,QPNT                          !!! from qvector
C Radial mesh:
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL               !!! from radmsh
	COMMON /BETPAR/ BET                                 !!! from multro
C Plane waves:
	COMMON /PLWMESH/NPLW,GPLW                           !!! from plwmsh
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                     !!! from readini
C Density:
	COMMON /DELRO/  DRHO,DMAG                           !!! from delrho
	COMMON /DPSRHO/ DRHOPS,DMAGPS,DRHOPS1               !!! from multrho
	COMMON /DROMULT/DELMRO,DPSMOM,DPSMOM1,DELMAD,DELMAG !!! from multrho
C Outputs:
	COMMON /UNIT/   IUN                                 !!! from readini
	COMMON /TXTEL/  TXTEL                               !!! from init
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
	DO ISPIN=1,NSPIN
	ITRAN=ISPIN
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO L=0,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	SL=SMT(ISORT)**L
C   CALCULATE MOMENTS OF THE INDUCED DENSITY WITHIN SPHERE
	DO IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=DRHO(IRAD,LM,IATOM,ISPIN)*
     &  RL(IRAD,L,ISORT)/SL*WEIGHT(IRAD,ISORT)/SQRT(4.D0*PI)
        ENDDO     
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DELMRO(LM,IATOM,ISPIN,IGPTB,MY)=WORK2(NRAD(ISORT))
C   CALCULATE INDUCED MAGNETIC MOMENTS
	DO IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=DMAG(IRAD,LM,IATOM,ITRAN)*
     &  RL(IRAD,L,ISORT)/SL*WEIGHT(IRAD,ISORT)/SQRT(4.D0*PI)
        ENDDO     
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DELMAG(LM,IATOM,ITRAN,IGPTB,MY)=WORK2(NRAD(ISORT))
        ENDDO     
        ENDDO     
        ENDDO     
        ENDDO     
C *** CALCULATE MOMENTS OF THE PSEUDOCHARGE DENSITY ***
	LMM=0
	DO ISPIN=1,NSPIN
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	LMM=MAX(LMM,ILSV(ISORT))
	DO L=0,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	DPSMOM(LM,IATOM,ISPIN,IGPTB,MY)=(0.D0,0.D0)
        ENDDO     
        ENDDO     
        ENDDO     
        ENDDO     
C  SET MULTIPOLE MOMENTS DUE TO CHANGE IN PSRHO
	DO IPLW=0,NPLW                       !!! over plane waves
	GX=(GPLW(1,IPLW)+QPNT(1))*2.D0*PI/PAR
	GY=(GPLW(2,IPLW)+QPNT(2))*2.D0*PI/PAR
	GZ=(GPLW(3,IPLW)+QPNT(3))*2.D0*PI/PAR
	AG=SQRT(GX**2+GY**2+GZ**2)
	AG2=AG*AG
C  SET SPHERICAL HARMONICS
	IF(AG.GE.1.D-10)THEN
	CALL SPHHARM(GX/AG,GY/AG,GZ/AG,LMM,YLM)
	ELSE
	YLM(1)=1.D0/SQRT(4.D0*PI)
	DO LM=2,(LMM+1)**2
	YLM(LM)=(0.D0,0.D0)
        ENDDO     
	ENDIF
	DO IATOM=1,NATOM                     !!! over atoms
	ISORT=IS(IATOM)
	CALL BESSR(AG*SMT(ISORT),BES,BESD,ILSV(ISORT)+1)
	SCP=(QPNT(1)+GPLW(1,IPLW))*TAU(1,IATOM)+
     &      (QPNT(2)+GPLW(2,IPLW))*TAU(2,IATOM)+
     &      (QPNT(3)+GPLW(3,IPLW))*TAU(3,IATOM)
	EXPT=EXP((0.D0,1.D0)*2.D0*PI*SCP)
	DO ISPIN=1,NSPIN                     !!! over spins
	DO L=0,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	IF(AG.GT.1.D-10)THEN
	DPSMOM(LM,IATOM,ISPIN,IGPTB,MY)=
     &  DPSMOM(LM,IATOM,ISPIN,IGPTB,MY)+
     &  4.D0*PI*SMT(ISORT)**2*DRHOPS(IPLW,ISPIN)*BES(L+1)*
     &  EXPT*DCONJG(YLM(LM))/AG*SQPI4
	ELSE
	DPSMOM(LM,IATOM,ISPIN,IGPTB,MY)=
     &  DPSMOM(LM,IATOM,ISPIN,IGPTB,MY)+
     &  4.D0*PI/3.D0*SMT(ISORT)**3*DRHOPS(IPLW,ISPIN)*
     &  EXPT*DCONJG(YLM(LM))*SQPI4
	ENDIF
        ENDDO     
        ENDDO     
        ENDDO                                !!! over spins
        ENDDO                                !!! over atoms
        ENDDO                                !!! over plane waves
C  CALCULATE AUXILARY PSEUDOCHARGE DENSITY (ITS COEFFICIENTS)
C  WHICH HAS THE SAME MULTIPOLES AS A TRUE DENSITY MINUS PSEUDODENSITY
	DO ISPIN=1,NSPIN
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	BT(0)=BET(0,ISORT)
	DO L=1,ILSV(ISORT)+1
	BT(L)=BET(L-1,ISORT)
        ENDDO     
	CALL REGHAN(SMT(ISORT),(0.D0,0.D0),SMT(ISORT),BT(0),
     &  RHAN(0),ILSV(ISORT)+1)
	DO L=0,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
C  GAUSSIAN MULTIPOLE MOMENT WITHIN SPHERE
	GSMOM=SQPI4*SMT(ISORT)*DBLE(2*L+1)*RHAN(L+1)
C  GAUSSIAN MULTIPOLE MOMENT IN WHOLE SPACE
C       GSMOM=SQPI4*SMT(ISORT)*DBLE(2*L+1)
	DPSMOM1(LM,IATOM,ISPIN,IGPTB,MY)=
     &  (DELMRO(LM,IATOM,ISPIN,IGPTB,MY)-
     &  DPSMOM(LM,IATOM,ISPIN,IGPTB,MY))/GSMOM
        ENDDO     
        ENDDO     
        ENDDO     
        ENDDO     
	END
