	SUBROUTINE DRHOHUB(IGPTB,MY,IPAN,IQPNT)
***********************************************************
*  Computes occupation numbers from the TOS-matrices.     *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NHSORT(NSORTMAX),IS(NPAT),NKAP(NPANMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
	COMPLEX*16 
     &    DTOSHH(LIMLMB,LIMLMB,NPAT,NKAPMAX,NKAPMAX)
     &   ,DTOSJJ(LIMLMT,LIMLMT,NPAT,NKAPMAX,NKAPMAX)
     &   ,DTOSHJ(LIMLMB,LIMLMT,NPAT,NKAPMAX,NKAPMAX)
     &   ,DTOSJH(LIMLMT,LIMLMB,NPAT,NKAPMAX,NKAPMAX)
     &   ,OHH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NPANMAX,NSPINMAX)
     &   ,OJH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NPANMAX,NSPINMAX)
     &   ,OHJ(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NPANMAX,NSPINMAX)
     &   ,OJJ(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NPANMAX,NSPINMAX)
     &   ,DELDHUB(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2),SUM
     &   ,DELMHUB(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX),LOG1,LOG
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /KAPPAR/ NPAN,NKAP                           !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS               !!! from init
        COMMON /STORE1/ DTOSHH,DTOSJH,DTOSHJ,DTOSJJ          !!! from deltos
        COMMON /SUMPAR/ OHH,OJH,OHJ,OJJ                     !!! from ovrpar
        COMMON /DELHUB/ DELDHUB,DELMHUB                     !!! from ttrintm
	COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /ORBS/   NORBS                               !!! from init
	COMMON /WORD/   NVAL                                !!! from nmtdat
	COMMON /UNIT/   IUN                                 !!! from init
	DATA PI/3.141592653589793D0/
	IF(IPAN.NE.1)RETURN
C ***** DO GLOBALLY OVER SPINORS ********
        DO 3000 IUPDN1=1,NSPIN                     !!! over spinors
        DO 2000 IUPDN =1,NSPIN                     !!! over spinors
C SET LONGITUDINAL AND TRANSVERSE COMPONENTS
            IF(IUPDN1.EQ.1.AND.IUPDN.EQ.1)THEN
        IF(NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2)GOTO2000
        ISPIN=1
        ITRAN=0
        ELSEIF(IUPDN1.EQ.2.AND.IUPDN.EQ.2)THEN
        IF(NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2)GOTO2000
        ISPIN=2
        ITRAN=0
        ELSEIF(IUPDN1.EQ.1.AND.IUPDN.EQ.2)THEN
        IF(NORBS.EQ.1.AND.MY.NE.+1)GOTO2000
        ISPIN=0
        ITRAN=1
        ELSEIF(IUPDN1.EQ.2.AND.IUPDN.EQ.1)THEN
        IF(NORBS.EQ.1.AND.MY.NE.-1)GOTO2000
        ISPIN=0
        ITRAN=2
        ENDIF
C READ CHANGE IN TOS/BOS-MATRICES
        IF(ISPIN.NE.0)CALL TOSFILES(IGPTB,MY,IPAN,ISPIN,IQPNT,42,'R')
        IF(ITRAN.NE.0)CALL TOSFILES(IGPTB,MY,IPAN,ITRAN,IQPNT,44,'R')
        DO 1000 IATOM=1,NATOM                      !!! over atoms in cell
        ISORT=IS(IATOM)
C  SET OCCUPATION NUMBERS TO ZERO
	DO L=0,ILSB(ISORT)                          !!! over l
        DO M1=-L,L                                  !!! over m1
        LM1=L*(L+1)+M1+1
        DO M=-L,L                                   !!! over m
        LM=L*(L+1)+M+1
        IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 ! ! (l,m'm)
        IF(ISPIN.NE.0)DELDHUB(IU,IATOM,ISPIN,IGPTB,MY)=(0.D0,0.D0)
        IF(ITRAN.NE.0)DELMHUB(IU,IATOM,ITRAN,IGPTB,MY)=(0.D0,0.D0)
	ENDDO                                       !!! over m1
        ENDDO                                       !!! over m
        ENDDO                                       !!! over l
	DO IKAP1=1,NKAP(IPAN)                       !!! over energies
	DO IKAP=1,NKAP(IPAN)                        !!! over energies
C  COMPUTE OCCUPATION NUMBERS
	DO L=0,ILSB(ISORT)                          !!! over l
        DO M1=-L,L                                  !!! over m1
        LM1=L*(L+1)+M1+1
        DO M=-L,L                                   !!! over m
        LM=L*(L+1)+M+1
        IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 ! ! (l,m'm)
	SUM=(0.D0,0.D0)
	IF(ISPIN.NE.0)THEN
        IF(LSPAN(L,ISORT,IKAP1,IPAN).AND.LSPAN(L,ISORT,IKAP,IPAN))THEN
        SUM=SUM+DTOSHH(LM1,LM,IATOM,IKAP1,IKAP)*
     &  OHH(IKAP1,IKAP,L,ISORT,IPAN,ISPIN)
        SUM=SUM-DTOSHJ(LM1,LM,IATOM,IKAP1,IKAP)*
     &  OHJ(IKAP1,IKAP,L,ISORT,IPAN,ISPIN)
        SUM=SUM-DTOSJH(LM1,LM,IATOM,IKAP1,IKAP)*
     &  OJH(IKAP1,IKAP,L,ISORT,IPAN,ISPIN)
        ENDIF
        SUM=SUM+DTOSJJ(LM1,LM,IATOM,IKAP1,IKAP)*
     &  OJJ(IKAP1,IKAP,L,ISORT,IPAN,ISPIN)
      	DELDHUB(IU,IATOM,ISPIN,IGPTB,MY)=
     &  DELDHUB(IU,IATOM,ISPIN,IGPTB,MY)+SUM
	ENDIF
	IF(ITRAN.NE.0)THEN
        IF(LSPAN(L,ISORT,IKAP1,IPAN).AND.LSPAN(L,ISORT,IKAP,IPAN))THEN
        SUM=SUM+DTOSHH(LM1,LM,IATOM,IKAP1,IKAP)*
     &  OHH(IKAP1,IKAP,L,ISORT,IPAN,ITRAN)
        SUM=SUM-DTOSHJ(LM1,LM,IATOM,IKAP1,IKAP)*
     &  OHJ(IKAP1,IKAP,L,ISORT,IPAN,ITRAN)
        SUM=SUM-DTOSJH(LM1,LM,IATOM,IKAP1,IKAP)*
     &  OJH(IKAP1,IKAP,L,ISORT,IPAN,ITRAN)
        ENDIF
        SUM=SUM+DTOSJJ(LM1,LM,IATOM,IKAP1,IKAP)*
     &  OJJ(IKAP1,IKAP,L,ISORT,IPAN,ITRAN)
      	DELMHUB(IU,IATOM,ITRAN,IGPTB,MY)=
     &  DELMHUB(IU,IATOM,ITRAN,IGPTB,MY)+SUM
	ENDIF
	ENDDO                                       !!! over m1
        ENDDO                                       !!! over m
        ENDDO                                       !!! over l
        ENDDO                                       !!! over energies
        ENDDO                                       !!! over energies
1000    CONTINUE                                    !!! over atoms
2000    CONTINUE                                    !!! over spinors
3000    CONTINUE                                    !!! over spinors
	END
