        SUBROUTINE DTOSPAR(IGPTB,MY,IPNT,ISGQ,IPAN,IQPNT)
***********************************************************
*  Calculate change in the number of states matrix (TOS)  *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,IKOV(NOPRMAX),ISG(NOPRMAX,NOPRMAX),IS(NPAT)
     &   ,IG0IG1(KMAX,NOPRMAX),IK0IK1(KMAX,NOPRMAX)
     &   ,NKAP(NPANMAX),NBNDC(NPANMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &   ,DTOSHH(LIMLMB,LIMLMB,NPAT,NKAPMAX,NKAPMAX)
     &   ,DTOSJH(LIMLMT,LIMLMB,NPAT,NKAPMAX,NKAPMAX)
     &   ,DTOSHJ(LIMLMB,LIMLMT,NPAT,NKAPMAX,NKAPMAX)
     &   ,DTOSJJ(LIMLMT,LIMLMT,NPAT,NKAPMAX,NKAPMAX)
     &   ,APH(LIMLMB,NDIMMAX*NSPINMAX,NKAPMAX),WT1 
     &   ,APJ(LIMLMT,NDIMMAX*NSPINMAX,NKAPMAX),WT2
     &   ,SPH(LIMLMB,NDIMMAX*NSPINMAX,NKAPMAX)
     &   ,SPJ(LIMLMT,NDIMMAX*NSPINMAX,NKAPMAX)
     &   ,DHMAT(NDIMMAX*NSPINMAX,NDIMMAX*NSPINMAX)
     &   ,DOMAT(NDIMMAX*NSPINMAX,NDIMMAX*NSPINMAX)
	COMPLEX*16 
     &    APHK(LIMLMB ,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &   ,APJK(LIMLMT1,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &   ,APHQ(LIMLMB ,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &   ,APJQ(LIMLMT1,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
	DIMENSION PNT(3,KMAX),EARR(NDIMMAX*NSPINMAX,KMAX,NPANMAX)
     &   ,WEIGQ(NBNDMAX*NSPINMAX,NBNDMAX*NSPINMAX,6)
     &   ,WGTOM(NBNDMAX*NSPINMAX,NBNDMAX*NSPINMAX,4)
     &   ,WEIGK(NBNDMAX*NSPINMAX,4),WGT(KMAX)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX),LOG1,LOG
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX),EXIST
	CHARACTER SCRFILE(100)*60
C Controls:
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE           !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM          !!! from init
	COMMON /ORBS/   NORBS                                  !!! from init
	COMMON /SPIN/   NSPIN                                  !!! from init
C Inputs:
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                      !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                  !!! from init
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT,NBNDC,POLUS          !!! from init
C Group:
	COMMON /INVERS/ INV,IKOV                               !!! from group
	COMMON /SUBGROUP/NSGQ,NGEQ,ISG                         !!! from symmsh
	COMMON /GROUPOUT/NGROUP                                !!! from group
C K-mesh:
	COMMON /MESH/   NPNT,PNT,WGT                           !!! from ttrmsh
	COMMON /SYMMESH/IG0IG1,IK0IK1                          !!! from symmsh
C Temporary:
	COMMON /STORE1/ DTOSHH,DTOSJH,DTOSHJ,DTOSJJ            !!! from deltos
	COMMON /STORE2/ DHMAT,DOMAT                            !!! from delmat
	COMMON /DENS/   APH,APJ,SPH,SPJ                        !!! tmp.storage
C Bands:
	COMMON /ENERGY/ EARR                                   !!! from delttr
	COMMON /EIGVEC/ APHK,APJK,APHQ,APJQ                    !!! from lmtvec
C Frequencies:
	COMMON /FREQU/  OMGR                                   !!! from init
C Outputs:
        COMMON /OUT0/   SCRFILE                                !!! from init
	COMMON /WORD/   NVAL                                   !!! from nmtdata
	DATA PI/3.141592653589793D0/
        IF(MODE.EQ.5)RETURN
C  SET POINT-GROUP INFORMATION
	IRK=ISG(1,ISGQ)       !!!  element "g"  in the main G-list
	IGK=IKOV(IRK)         !!!  element "g"  after Kovalev
	IPNTK=IPNT            !!!  point   "k"
	IRQ=IG0IG1(IPNT,IRK)  !!!  element "g'" in the main G-list
	IGQ=IKOV(IRQ)         !!!  element "g'" after Kovalev
	IPNTQ=IK0IK1(IPNT,IRK)!!!  point   "k'" such that g*k+q=g'*k'
C  READ 1/E TETRAHEDRON WEIGHTS FOR BRILLOUIN ZONE INTEGRATION
	IREC=1+IPNTK+NPNT*(ISGQ-1)
	IF(IPAN.EQ.1)THEN
        READ(40,REC=IREC)WGTQ1,(((WEIGQ(IBANC,IBANC1,IC),
     &  IBANC=1,NBNDC(1)*NSPIN),IBANC1=1,NBNDC(1)*NSPIN),
     &  IC=1,6),((WEIGK(IBANC,IC),IBANC=1,NBNDC(1)*NSPIN),
     &  IC=1,4),(((WGTOM(IBANC,IBANC1,IC),IBANC=1,
     &  NBNDC(1)*NSPIN),IBANC1=1,NBNDC(1)*NSPIN),IC=1,4)
	ELSE ! only geometrical weigths are neccessary
	READ(40,REC=IREC)WGTQ1
	ENDIF
C ***** DO GLOBALLY OVER SPINORS ********
        DO 3000 IUPDN1=1,NSPIN                          !!! over spinors
        IF(NORBS.EQ.2)IORBS1=IUPDN1
        IF(NORBS.EQ.1)IORBS1=1
        DO 2000 IUPDN =1,NSPIN                          !!! over spinors
        IF(NORBS.EQ.2)IORBS=IUPDN
        IF(NORBS.EQ.1)IORBS=1
C SET LONGITUDINAL AND TRANSVERSE COMPONENTS
            IF(IUPDN1.EQ.1.AND.IUPDN.EQ.1)THEN
        IF(NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2)GOTO2000
        ISPIN=1
        ITRAN=0
	SIGNF=1.D0
        ELSEIF(IUPDN1.EQ.2.AND.IUPDN.EQ.2)THEN
        IF(NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2)GOTO2000
        ISPIN=2
        ITRAN=0
	SIGNF=1.D0
        ELSEIF(IUPDN1.EQ.1.AND.IUPDN.EQ.2)THEN
        IF(NORBS.EQ.1.AND.MY.NE.+1)GOTO2000
        ISPIN=0
        ITRAN=1
	SIGNF=+SQRT(2.D0)
        ELSEIF(IUPDN1.EQ.2.AND.IUPDN.EQ.1)THEN
        IF(NORBS.EQ.1.AND.MY.NE.-1)GOTO2000
        ISPIN=0
        ITRAN=2
	SIGNF=-SQRT(2.D0)
        ENDIF
C READ CHANGE IN TOS/BOS-MATRICES
        IF(ISPIN.NE.0)CALL TOSFILES(IGPTB,MY,IPAN,ISPIN,IQPNT,42,'R')
        IF(ITRAN.NE.0)CALL TOSFILES(IGPTB,MY,IPAN,ITRAN,IQPNT,44,'R')
C  **** CALCULATE CONTRIBUTION TO THE CHANGE IN THE TOS-MATRIX GOING 
C  **** FROM A SINGLE K-POINT OF BZ AND ALL BAND TRASITIONS 
	DO 1000 IATOM=1,NATOM                          !!! over iatom
	ISORT=IS(IATOM)
	DO IKAP=1,NKAP(IPAN)                           !!! over energies
	DO IBNDS=1,NSPIN                               !!! over spin subbands
	DO IBNDT=1,NBNDF(IPAN)                         !!! over filled bands
	IBNDC=IBNDT-NBNDE(IPAN)+1
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
C  CALCULATE CONVOLUTIONS OVER BANDS
	DO L=0,ILST(ISORT)                             !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	DO M=-L,L                                      !!! over m
	LM=L*(L+1)+M+1
	IF(L.LE.ILSB(ISORT))
     &  APH(LM,IBAND,IKAP)=(0.D0,0.D0)
	APJ(LM,IBAND,IKAP)=(0.D0,0.D0)
	IF(L.LE.ILSB(ISORT))
     &  SPH(LM,IBAND,IKAP)=(0.D0,0.D0)
	SPJ(LM,IBAND,IKAP)=(0.D0,0.D0)
C  1) CALCULATE CONTRIBUTION FROM UNOCCUPIED STATES
	DO IBNDS1=1,NSPIN                              !!! over spin subbands
	DO IBNDT1=NBNDE(IPAN),NBNDT(IPAN)              !!! over empty bands
	IF(IPAN.GT.1)STOP'<DELTOS>: Error in empty bands for ipan>1'
	IBNDC1=IBNDT1-NBNDE(IPAN)+1
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
C  FOR THE FERMI SURFACE BANDS
	IF(IBNDT.GE.NBNDE(IPAN).AND.IBNDT1.LE.NBNDF(IPAN))THEN
	DEK1=OMGR+EARR(IBAND,IPNTK,IPAN)-EARR(IBAND1,IPNTQ,IPAN)
        DEK2=OMGR+EARR(IBAND1,IPNTK,IPAN)-EARR(IBAND,IPNTQ,IPAN)
C  1/E TETRAHEDRON WEIGHTS
 	WQ1=    WEIGQ(IBANC,IBANC1,1) !!! f(kj)*[1-f(k+qj')]/[E(kj)-E(k+qj')]
 	WQ2=    WEIGQ(IBANC1,IBANC,2) !!! [1-f(kj')]*f(k+qj)/[E(kj')-E(k+qj)]
C  WEIGHTS FROM DENSITY-OF-STATES AT EF 
 	WQ1=WQ1+WEIGQ(IBANC,IBANC1,3) !!! +0.5*Delta[E(kj )-Ef]
 	WQ2=WQ2+WEIGQ(IBANC1,IBANC,4) !!! -0.5*Delta[E(kj')-Ef]
C  WEIGHTS FROM LORENTZIAN SMEARING
	WQ1=WQ1+WEIGK(IBANC,1)*DEK1/(DEK1**2+POLUS**2) !!! f(kj)
	WQ2=WQ2+WEIGK(IBANC,2)*DEK2/(DEK2**2+POLUS**2) !!! f(k+qj')
 	WQ1=WQ1-WEIGQ(IBANC,IBANC1,5) !!! f(kj)*[1-f(k+qj')]/[E(kj)-E(k+qj')]
 	WQ2=WQ2-WEIGQ(IBANC1,IBANC,6) !!! [1-f(kj')]*f(k+qj)/[E(kj')-E(k+qj)]
C  WEIGHTS FROM THE IMAGINARY PART
        WI1=-PI*WGTOM(IBANC,IBANC1,1) !!! (f(kj)-f(k+qj')*d(E(kj)-E(k+qj')+Omega)
        WI2=0.D0                      !!! (f(kj')-f(k+qj)*d(E(kj')-E(k+qj)+Omega)
C  OTHERWISE, USUAL TETRAHEDRON WEIGHTS
	ELSEIF(IBNDT.GE.NBNDE(IPAN).AND.IBNDT1.GT.NBNDF(IPAN))THEN
	DEK1=OMGR+EARR(IBAND,IPNTK,IPAN)-EARR(IBAND1,IPNTQ,IPAN)
        DEK2=OMGR+EARR(IBAND1,IPNTK,IPAN)-EARR(IBAND,IPNTQ,IPAN)
		IF(ABS(DEK1).LE.1.D-10)THEN
		IF(ABS(WEIGK(IBANC,1)).GE.1.D-10)
     &  	PRINT*,'<DELTOS> :: ERROR IN WEIGHTS'
		WEIGK(IBANC,1)=0.D0
		DEK1=1.D0
		ENDIF
		IF(ABS(DEK2).LE.1.D-10)THEN
		IF(ABS(WEIGK(IBANC,2)).GE.1.D-10)
     &  	PRINT*,'<DELTOS> :: ERROR IN WEIGHTS'
		WEIGK(IBANC,2)=0.D0
		DEK2=1.D0
		ENDIF
	WQ1=WEIGK(IBANC,1)/DEK1     !!! f(kj)  /[E(kj)-E(k+qj')]
	WQ2=WEIGK(IBANC,2)/DEK2     !!! f(k+qj)/[E(kj')-E(k+qj)]
	WI1=0.D0
	WI2=0.D0
	ELSEIF(IBNDT.LT.NBNDE(IPAN).AND.IBNDT1.LE.NBNDF(IPAN))THEN
	DEK1=OMGR+EARR(IBAND,IPNTK,IPAN)-EARR(IBAND1,IPNTQ,IPAN)
        DEK2=OMGR+EARR(IBAND1,IPNTK,IPAN)-EARR(IBAND,IPNTQ,IPAN)
		IF(ABS(DEK1).LE.1.D-10)THEN
		IF(ABS(WGTQ1-WEIGK(IBANC1,2)).GE.1.D-10)
     &  	PRINT*,'<DELTOS> :: ERROR IN WEIGHTS'
		WEIGK(IBANC1,2)=WGTQ1
		DEK1=1.D0
		ENDIF
		IF(ABS(DEK2).LE.1.D-10)THEN
		IF(ABS(WGTQ1-WEIGK(IBANC1,1)).GE.1.D-10)
     &  	PRINT*,'<DELTOS> :: ERROR IN WEIGHTS'
		WEIGK(IBANC1,1)=WGTQ1
		DEK1=1.D0
		ENDIF
	WQ1=(WGTQ1-WEIGK(IBANC1,2))/DEK1 !!! [1-f(k+qj')]/[E(kj)-E(k+qj')]
	WQ2=(WGTQ1-WEIGK(IBANC1,1))/DEK2 !!! [1-f(kj')  ]/[E(kj')-E(k+qj)]
	WI1=0.D0
	WI2=0.D0
	ELSEIF(IBNDT.LT.NBNDE(IPAN).AND.IBNDT1.GT.NBNDF(IPAN))THEN
	DEK1=OMGR+EARR(IBAND,IPNTK,IPAN)-EARR(IBAND1,IPNTQ,IPAN)
        DEK2=OMGR+EARR(IBAND1,IPNTK,IPAN)-EARR(IBAND,IPNTQ,IPAN)
	WQ1=WGTQ1/DEK1              !!! 1/[E(kj)-E(k+qj')]
	WQ2=WGTQ1/DEK2              !!! 1/[E(kj')-E(k+qj)]
	WI1=0.D0
	WI2=0.D0
	ENDIF
C  SET TOTAL COMPLEX WEIGHT
	IF(MODE.EQ.1.OR.MODE.EQ.2.OR.MODE.EQ.3)THEN
	WT1=DCMPLX(WQ1,WI1)
	WT2=DCMPLX(WQ2,WI2)
C  COMPUTE IMAGINARY PART ONLY
	ELSEIF(MODE.EQ.4)THEN
	WT1=DCMPLX(WI1,0.D0)
	WT2=DCMPLX(WI2,0.D0)
	ENDIF
C  SET UP CONTRIBUTION
	ESUM1=OMGR+EARR(IBAND,IPNTK,IPAN)+EARR(IBAND1,IPNTQ,IPAN)
	ESUM2=OMGR+EARR(IBAND1,IPNTK,IPAN)+EARR(IBAND,IPNTQ,IPAN)
	IF((IUPDN1.EQ.IBNDS1.AND.NORBS.EQ.1).OR.NORBS.EQ.2)THEN
   	IF(LOG)
     &  APH(LM,IBAND,IKAP)=APH(LM,IBAND,IKAP)+
     &  APHQ(LM,IATOM,IKAP,IORBS1,IBAND1)*(
     &  DHMAT(IBAND1,IBAND)-0.5D0*ESUM1*DOMAT(IBAND1,IBAND))*
     &  WT1*SIGNF
   	APJ(LM,IBAND,IKAP)=APJ(LM,IBAND,IKAP)+
     &  APJQ(LM,IATOM,IKAP,IORBS1,IBAND1)*(
     &  DHMAT(IBAND1,IBAND)-0.5D0*ESUM1*DOMAT(IBAND1,IBAND))*
     &  WT1*SIGNF
	ENDIF
	IF((IUPDN.EQ.IBNDS1.AND.NORBS.EQ.1).OR.NORBS.EQ.2)THEN
   	IF(LOG)
     &  SPH(LM,IBAND,IKAP)=SPH(LM,IBAND,IKAP)+
     &  CONJG(APHK(LM,IATOM,IKAP,IORBS,IBAND1))*(
     &  DHMAT(IBAND,IBAND1)-0.5D0*ESUM2*DOMAT(IBAND,IBAND1))*
     &  WT2*SIGNF
   	SPJ(LM,IBAND,IKAP)=SPJ(LM,IBAND,IKAP)+
     &  CONJG(APJK(LM,IATOM,IKAP,IORBS,IBAND1))*(
     &  DHMAT(IBAND,IBAND1)-0.5D0*ESUM2*DOMAT(IBAND,IBAND1))*
     &  WT2*SIGNF
	ENDIF
        ENDDO                                          !!! over empty bands
	ENDDO                                          !!! over spin subbands
C  2) CONTRIBUTION FROM ALL STATES
	DO IBNDS1=1,NSPIN                              !!! over spin subbands
	DO IBNDT1=1,NBNDT(IPAN)                        !!! over all bands
	IBNDC1=IBNDT1-NBNDE(IPAN)+1
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
        IF(IBNDT.GE.NBNDE(IPAN))THEN
        WQ1=WEIGK(IBANC,1)          !!! f(kj)
        WQ2=WEIGK(IBANC,2)          !!! f(k+qj)
	WI1=0.D0
	WI2=0.D0
        ELSEIF(IBNDT.LT.NBNDE(IPAN))THEN
        WQ1=WGTQ1                   !!! 1
        WQ2=WGTQ1                   !!! 1
	WI1=0.D0
	WI2=0.D0
        ENDIF
C  SET TOTAL COMPLEX WEIGHT
        IF(MODE.EQ.1.OR.MODE.EQ.2.OR.MODE.EQ.3)THEN
        WT1=DCMPLX(WQ1,WI1)
        WT2=DCMPLX(WQ2,WI2)
C  COMPUTE IMAGINARY PART ONLY
        ELSEIF(MODE.EQ.4)THEN
        WT1=DCMPLX(WI1,0.D0)
        WT2=DCMPLX(WI2,0.D0)
        ENDIF
C  SET UP CONTRIBUTION
	IF((IUPDN1.EQ.IBNDS1.AND.NORBS.EQ.1).OR.NORBS.EQ.2)THEN
        IF(LOG)
     &  APH(LM,IBAND,IKAP)=APH(LM,IBAND,IKAP)-
     &  APHQ(LM,IATOM,IKAP,IORBS1,IBAND1)*
     &  0.5D0*DOMAT(IBAND1,IBAND)*WT1*SIGNF
        APJ(LM,IBAND,IKAP)=APJ(LM,IBAND,IKAP)-
     &  APJQ(LM,IATOM,IKAP,IORBS1,IBAND1)*
     &  0.5D0*DOMAT(IBAND1,IBAND)*WT1*SIGNF
	ENDIF
	IF((IUPDN.EQ.IBNDS1.AND.NORBS.EQ.1).OR.NORBS.EQ.2)THEN
        IF(LOG)
     &  SPH(LM,IBAND,IKAP)=SPH(LM,IBAND,IKAP)+
     &  DCONJG(APHK(LM,IATOM,IKAP,IORBS,IBAND1))*
     &  0.5D0*DOMAT(IBAND,IBAND1)*WT2*SIGNF
        SPJ(LM,IBAND,IKAP)=SPJ(LM,IBAND,IKAP)+
     &  DCONJG(APJK(LM,IATOM,IKAP,IORBS,IBAND1))*
     &  0.5D0*DOMAT(IBAND,IBAND1)*WT2*SIGNF
	ENDIF
        ENDDO                                          !!! over all bands
	ENDDO                                          !!! over spin subbands
        ENDDO                                          !!! over m
        ENDDO                                          !!! over l
        ENDDO                                          !!! over filled bands
	ENDDO                                          !!! over spin subbands
        ENDDO                                          !!! over energies
C  CALCULATE CONTRIBUTION FROM THIS K-POINT TO THE CHANGE IN TOS-MATRIX
	DO IKAP1=1,NKAP(IPAN)                          !!! over energies
	DO IKAP =1,NKAP(IPAN)                          !!! over energies
	DO IBNDS=1,NSPIN                               !!! over spin subbands
	DO IBNDT=1,NBNDF(IPAN)                         !!! over filled bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO L1=0,ILST(ISORT)                            !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	DO M1=-L1,L1                                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO L=0,ILST(ISORT)                             !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	DO M=-L,L                                      !!! over m
	LM=L*(L+1)+M+1
	IF((IUPDN.EQ.IBNDS.AND.NORBS.EQ.1).OR.NORBS.EQ.2)THEN
	IF(LOG1.AND.LOG)DTOSHH(L1M1,LM,IATOM,IKAP1,IKAP)=
     &  DTOSHH(L1M1,LM,IATOM,IKAP1,IKAP)+
     &  CONJG(APHK(L1M1,IATOM,IKAP1,IORBS,IBAND))*APH(LM,IBAND,IKAP)
	IF(LOG1)DTOSHJ(L1M1,LM,IATOM,IKAP1,IKAP)=
     &  DTOSHJ(L1M1,LM,IATOM,IKAP1,IKAP)+
     &  CONJG(APHK(L1M1,IATOM,IKAP1,IORBS,IBAND))*APJ(LM,IBAND,IKAP)
	IF(LOG)DTOSJH(L1M1,LM,IATOM,IKAP1,IKAP)=
     &  DTOSJH(L1M1,LM,IATOM,IKAP1,IKAP)+
     &  CONJG(APJK(L1M1,IATOM,IKAP1,IORBS,IBAND))*APH(LM,IBAND,IKAP)
	DTOSJJ(L1M1,LM,IATOM,IKAP1,IKAP)=
     &  DTOSJJ(L1M1,LM,IATOM,IKAP1,IKAP)+
     &  CONJG(APJK(L1M1,IATOM,IKAP1,IORBS,IBAND))*APJ(LM,IBAND,IKAP)
	ENDIF
	IF((IUPDN1.EQ.IBNDS.AND.NORBS.EQ.1).OR.NORBS.EQ.2)THEN
	IF(LOG1.AND.LOG)DTOSHH(L1M1,LM,IATOM,IKAP1,IKAP)=
     &  DTOSHH(L1M1,LM,IATOM,IKAP1,IKAP)-
     &  SPH(L1M1,IBAND,IKAP1)*APHQ(LM,IATOM,IKAP,IORBS1,IBAND)
	IF(LOG1)DTOSHJ(L1M1,LM,IATOM,IKAP1,IKAP)=
     &  DTOSHJ(L1M1,LM,IATOM,IKAP1,IKAP)-
     &  SPH(L1M1,IBAND,IKAP1)*APJQ(LM,IATOM,IKAP,IORBS1,IBAND)
	IF(LOG)DTOSJH(L1M1,LM,IATOM,IKAP1,IKAP)=
     &  DTOSJH(L1M1,LM,IATOM,IKAP1,IKAP)-
     &  SPJ(L1M1,IBAND,IKAP1)*APHQ(LM,IATOM,IKAP,IORBS1,IBAND)
	DTOSJJ(L1M1,LM,IATOM,IKAP1,IKAP)=
     &  DTOSJJ(L1M1,LM,IATOM,IKAP1,IKAP)-
     &  SPJ(L1M1,IBAND,IKAP1)*APJQ(LM,IATOM,IKAP,IORBS1,IBAND)
	ENDIF
        ENDDO                                          !!! over m
        ENDDO                                          !!! over l
        ENDDO                                          !!! over m1
        ENDDO                                          !!! over l1
        ENDDO                                          !!! over filled bands
	ENDDO                                          !!! over spin subbands
        ENDDO                                          !!! over energies
        ENDDO                                          !!! over energies
1000    CONTINUE                                       !!! over atoms
C STORE CHANGE IN TOS/BOS-MATRICES
        IF(ISPIN.NE.0)CALL TOSFILES(IGPTB,MY,IPAN,ISPIN,IQPNT,42,'W')
        IF(ITRAN.NE.0)CALL TOSFILES(IGPTB,MY,IPAN,ITRAN,IQPNT,44,'W')
2000    CONTINUE                                       !!! over spinors
3000    CONTINUE                                       !!! over spinors
	RETURN
	END


	SUBROUTINE TOSFILES(IGPTB,MY,IPAN,ISPIN,IQPNT,ICHN,TOPER)
***********************************************************
*  Reads/writes change in TOS/BOS-matrices.               *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,NKAP(NPANMAX),IS(NPAT),NBNDC(NPANMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &   ,DTOSHH(LIMLMB,LIMLMB,NPAT,NKAPMAX,NKAPMAX)
     &   ,DTOSJH(LIMLMT,LIMLMB,NPAT,NKAPMAX,NKAPMAX)
     &   ,DTOSHJ(LIMLMB,LIMLMT,NPAT,NKAPMAX,NKAPMAX)
     &   ,DTOSJJ(LIMLMT,LIMLMT,NPAT,NKAPMAX,NKAPMAX)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX),LOG1,LOG
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX),EXIST
        CHARACTER TOPER*1,SCNFILE(0:NENVMAX,-1:2,100)*60
     &   ,SCRFILE(100)*60,STATUS*3,NFILE*60
C Controls:
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE           !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM          !!! from init
	COMMON /ORBS/   NORBS                                  !!! from init
	COMMON /SPIN/   NSPIN                                  !!! from init
C Inputs:
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                      !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                  !!! from init
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT,NBNDC                !!! from init
C Temporary:
	COMMON /STORE1/ DTOSHH,DTOSJH,DTOSHJ,DTOSJJ            !!! from deltos
C Outputs:
        COMMON /OUT0PH/ SCNFILE                                !!! from init
        COMMON /OUT0/   SCRFILE                                !!! from init
	COMMON /WORD/   NVAL                                   !!! from nmtdata
	DATA PI/3.141592653589793D0/
C SCRATCH FILE FOR STORING CHANGE IN THE TOS-MATRIX
        NRECL=0
        DO IATOM=1,NATOM
        ISORT=IS(IATOM)
        LMAXH=((ILSB(ISORT)+1)**2+(ILST(ISORT)+1)**2)**2
        NRECL=MAX(NRECL,NVAL*LMAXH)
        ENDDO
        NFILE=SCNFILE(IGPTB,MY,ICHN)
        INQUIRE(FILE=NFILE,EXIST=EXIST)
        IF(.NOT.EXIST)STATUS='NEW'
        IF(     EXIST)STATUS='OLD'
C *** DELETE FILE
        IF(TOPER.EQ.'D')THEN
	NRECL=4
        OPEN(UNIT=ICHN,FILE=NFILE,STATUS=STATUS,FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NRECL)
        CLOSE(UNIT=ICHN,STATUS='DELETE')
        RETURN
        ENDIF
        OPEN(UNIT=ICHN,FILE=NFILE,STATUS=STATUS,ACCESS='DIRECT',
     &  FORM='UNFORMATTED',RECL=NRECL)
C READ/WRITE ACCORDING TO <<TOPER>>
        DO IATOM=1,NATOM               !!! over atoms
	ISORT=IS(IATOM)
        DO IKAP1=1,NKAP(IPAN)          !!! over ikap1
        DO IKAP=1,NKAP(IPAN)           !!! over ikap
        IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)
        IF(NORBS.EQ.2.OR.MY.EQ.0.OR.MY.EQ.2)
     &  IREC=IREC+NKAP(IPAN)**2*NATOM*(ISPIN-1)
	IF(TOPER.EQ.'R')
     &  READ(ICHN,REC=IREC)((DTOSHH(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((DTOSJH(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((DTOSHJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((DTOSJJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
	IF(TOPER.EQ.'W')
     &  WRITE(ICHN,REC=IREC)((DTOSHH(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((DTOSJH(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((DTOSHJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((DTOSJJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
        ENDDO                          !!! over ikap
        ENDDO                          !!! over ikap1
        ENDDO                          !!! over atoms
	CLOSE(ICHN)
        RETURN
	END


 
	SUBROUTINE DSNULTOS(IGPTB,MY,IPAN,IQPNT)
***********************************************************
*  Initialize change in the TOS-matrix.                   *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,NKAP(NPANMAX),IS(NPAT),NBNDC(NPANMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &   ,DTOSHH(LIMLMB,LIMLMB,NPAT,NKAPMAX,NKAPMAX)
     &   ,DTOSJH(LIMLMT,LIMLMB,NPAT,NKAPMAX,NKAPMAX)
     &   ,DTOSHJ(LIMLMB,LIMLMT,NPAT,NKAPMAX,NKAPMAX)
     &   ,DTOSJJ(LIMLMT,LIMLMT,NPAT,NKAPMAX,NKAPMAX)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX),LOG1,LOG
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX),EXIST
	CHARACTER SCRFILE(100)*60
C Controls:
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE           !!! from readini
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM          !!! from readini
	COMMON /ORBS/   NORBS                                  !!! from readini
	COMMON /SPIN/   NSPIN                                  !!! from readini
C Inputs:
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                      !!! from readini
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                  !!! from readini
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT,NBNDC                !!! from readini
C Temporary:
	COMMON /STORE1/ DTOSHH,DTOSJH,DTOSHJ,DTOSJJ            !!! from deltos
C Outputs:
        COMMON /OUT0/   SCRFILE                                !!! from readini
	COMMON /WORD/   NVAL                                   !!! from nmtdata
	DATA PI/3.141592653589793D0/
C  SET CHANGE IN THE TOS-MATRIX TO ZERO
	DO IKAP1=1,NKAP(IPAN)                             !!! over energies
	DO IKAP=1,NKAP(IPAN)                              !!! over energies
	DO IATOM=1,NATOM                                  !!! over iatom
	ISORT=IS(IATOM)
	DO L1=0,ILST(ISORT)                               !!! over l1
	LOG1=.FALSE.
	IF(L1.LE.ILSB(ISORT))LOG1=.TRUE.
	DO M1=-L1,L1                                      !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO L=0,ILST(ISORT)                                !!! over l
	LOG=.FALSE.
	IF(L.LE.ILSB(ISORT))LOG=.TRUE.
	DO M=-L,L                                         !!! over m
	LM=L*(L+1)+M+1
	IF(LOG1.AND.LOG)
     &  DTOSHH(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	IF(LOG1)
     &  DTOSHJ(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	IF(LOG)
     &  DTOSJH(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	DTOSJJ(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
        ENDDO                                             !!! over m
        ENDDO                                             !!! over l
        ENDDO                                             !!! over m1
        ENDDO                                             !!! over l1
        ENDDO                                             !!! over atoms
        ENDDO                                             !!! over energies
        ENDDO                                             !!! over energies
C  WRITE ZEROES
	DO ISPIN=1,NSPIN
	ITRAN=ISPIN
	IF((NORBS.EQ.1.AND.(MY.EQ.0.OR.MY.EQ.2)).OR.NORBS.EQ.2)
     &  CALL TOSFILES(IGPTB,MY,IPAN,ISPIN,IQPNT,42,'W')
	IF((NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2).OR.NORBS.EQ.2)
     &  CALL TOSFILES(IGPTB,MY,IPAN,ITRAN,IQPNT,44,'W')
	ENDDO
	END
