	SUBROUTINE PRINT2
***********************************************
*  Print data on the potential and density    *
***********************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),ISPL(NSORTMAX)
     &    ,NRAD(NSORTMAX)
	COMPLEX*16 V(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX),EXPGR
     &    ,RHOPS(0:NPLWMAX,NSPINMAX),RHOPS1(0:NPLWMAX,NSPINMAX)
     &    ,RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX)
     &    ,PSMOM1(NSYMMAX,NPAT,NSPINMAX)
     &    ,PSMOM(NSYMMAX,NPAT,NSPINMAX)
     &    ,AMTOT(NSYMMAX,NPAT,NSPINMAX)
     &    ,VPS(0:NPLWMAX,NSPINMAX)
	DIMENSION SMT(NSORTMAX),VMT(NSORTMAX,NSPINMAX),ORTH(2:3)
     &   ,ROCOR(0:NRADMAX,NSORTMAX,NSPINMAX),GPLW(3,0:NPLWMAX)
     &   ,VSF(NSORTMAX,NSPINMAX),Z(NSORTMAX),ZCOR(NSORTMAX)
     &   ,VSPH(0:NRADMAX,NSORTMAX,NSPINMAX),SPLIT(NSORTMAX)
     &   ,TAU(3,NPAT)
	CHARACTER TXTEL(NSORTMAX)*10,TXTSP(2)*2
	COMMON /CONTROL/MAN,LMTO,NLR,NOVR                   !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /POTCOM/ SWZ,SMT,VSPH,V                      !!! from vfull
	COMMON /BASIS/  TAU                                 !!! from init
	COMMON /RADMESH/NRAD                                !!! from radmsh
	COMMON /DENS/   RO,ROVALDS,ROCOR                    !!! from rofull
	COMMON /PSVCOM/ VPS                                 !!! from vpseudo
	COMMON /PSRHO/  RHOPS,RHOPS1                        !!! from vcftr
	COMMON /VZERO/  VMT0,VMT,VSF0,VSF,VAV               !!! from vzero
	COMMON /MULTRO/ Z,ZCOR,AMTOT,PSMOM,PSMOM1           !!! from multro
	COMMON /PLWMESH/NPLW,GPLW                           !!! from plwmsh
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                     !!! from init
	COMMON /SPIN/   NSPIN,SPLIT,ISPL                    !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /TXTEL/  TXTEL,TXTSP                         !!! from init
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
C  PRINT POTENTIAL AND DENSITY DATA
	SINT=0.D0
	ZPSD=OMEGAC*(RHOPS(0,1)+RHOPS(0,NSPIN))/2.D0*DBLE(NSPIN)
	ZINT=ZPSD
	ZAUX=0.D0
	AMTS=0.D0
	AINT=OMEGAC*(RHOPS(0,1)-RHOPS(0,NSPIN))
	DO 20 IATOM=1,NATOM
	ISORT=IS(IATOM)
	WRITE(IUN,1000)TXTEL(ISORT),IATOM
	DO 10 ISPIN=1,NSPIN
C  POTENTIAL AND DENSITY AT THE SPHERE
	IF(NSPIN.EQ.1)
     &  WRITE(IUN,1010)
     &  DREAL(V(NRAD(ISORT),1,IATOM,ISPIN))/SQPI4+VMT0,
     &  DREAL(RO(NRAD(ISORT),1,IATOM,ISPIN))/SQPI4
	IF(NSPIN.EQ.2)WRITE(IUN,1020)TXTSP(ISPIN),
     &  DREAL(V(NRAD(ISORT),1,IATOM,ISPIN))/SQPI4+VMT0,
     &  TXTSP(ISPIN),DREAL(RO(NRAD(ISORT),1,IATOM,ISPIN))/SQPI4
C  POTENTIAL AND DENSITY AT THE CENTER OF ATOM
	RHO0=0.D0
	VPS0=0.D0
	RHOS=0.D0
	VPSS=0.D0
	DO 5 IPLW=0,NPLW
	SCP=GPLW(1,IPLW)*TAU(1,IATOM)+
     &      GPLW(2,IPLW)*TAU(2,IATOM)+
     &      GPLW(3,IPLW)*TAU(3,IATOM)
	GS=SQRT(GPLW(1,IPLW)**2+GPLW(2,IPLW)**2+GPLW(3,IPLW)**2)*
     &  2.D0*PI/PAR*SMT(ISORT)
	EXPGR=EXP((0.D0,1.D0)*2.D0*PI*SCP)
	RHO0=RHO0+RHOPS(IPLW,ISPIN)*EXPGR
	VPS0=VPS0+VPS  (IPLW,ISPIN)*EXPGR
	IF(GS.GE.1.D-10)RHOS=RHOS+RHOPS(IPLW,ISPIN)*EXPGR*SIN(GS)/GS
	IF(GS.LT.1.D-10)RHOS=RHOS+RHOPS(IPLW,ISPIN)*EXPGR
	IF(GS.GE.1.D-10)VPSS=VPSS+VPS  (IPLW,ISPIN)*EXPGR*SIN(GS)/GS
	IF(GS.LT.1.D-10)VPSS=VPSS+VPS  (IPLW,ISPIN)*EXPGR
    5   CONTINUE
	IF(NSPIN.EQ.1)
     &  WRITE(IUN,1030)VPSS+VMT0,RHOS
	IF(NSPIN.EQ.2)WRITE(IUN,1040)TXTSP(ISPIN),VPSS+VMT0,
     &  TXTSP(ISPIN),RHOS
	IF(NSPIN.EQ.1)
     &  WRITE(IUN,1070)VPS0+VMT0,RHO0
	IF(NSPIN.EQ.2)WRITE(IUN,1080)TXTSP(ISPIN),VPS0+VMT0,
     &  TXTSP(ISPIN),RHO0
   10   CONTINUE
C  INTERSTITIAL CHARGE AMD MAGNETISATION
	ZAUX=ZAUX-(PSMOM1(1,IATOM,1)+PSMOM1(1,IATOM,NSPIN))/
     &  2.D0*DBLE(NSPIN)*SQPI4*SMT(ISORT)
	ZINT=ZINT-(PSMOM(1,IATOM,1)+PSMOM(1,IATOM,NSPIN))/
     &  2.D0*DBLE(NSPIN)
	SINT=SINT-DREAL(AMTOT(1,IATOM,1)+AMTOT(1,IATOM,NSPIN))/
     &  2.D0*DBLE(NSPIN)
	AMTS=AMTS+DREAL(AMTOT(1,IATOM,1)-AMTOT(1,IATOM,NSPIN))
	AINT=AINT-DREAL(PSMOM(1,IATOM,1)-PSMOM(1,IATOM,NSPIN))
C  PRINT MAGNETISATION
	IF(NSPIN.EQ.2)THEN
	WRITE(IUN,1090)DREAL(AMTOT(1,IATOM,1)-AMTOT(1,IATOM,NSPIN)),
     &  DREAL(PSMOM(1,IATOM,1)-PSMOM(1,IATOM,NSPIN))
	IF(ABS(SPLIT(IS(IATOM))).GE.1.D-10)
     &  WRITE(IUN,1100)DREAL(AMTOT(1,IATOM,1)-AMTOT(1,IATOM,NSPIN))/
     &  SPLIT(ISORT),DREAL(PSMOM(1,IATOM,1)-PSMOM(1,IATOM,NSPIN))/
     &  SPLIT(ISORT)
	ENDIF
  20    CONTINUE
	WRITE(IUN,1110)VMT0
	WRITE(IUN,1120)VAV
	WRITE(IUN,1130)SINT
	WRITE(IUN,1140)ZINT
	WRITE(IUN,1150)ZPSD/ZAUX
	IF(NSPIN.EQ.2)WRITE(IUN,1160)AINT
	IF(NSPIN.EQ.2)WRITE(IUN,1170)AMTS+AINT
1000  FORMAT(1X,'Input data ',A10,' in the position ',I3,' ------->')
1010  FORMAT(1X,'   V(S)=',G14.7,'  |     RO(S)=',G14.7)
1020  FORMAT(1X,'V-',A2,'(S)=',G14.7,'  | RO-',A2,'(S)=',G14.7)
1030  FORMAT(1X,'   P(S)=',G14.7,'  |     PD(S)=',G14.7)
1040  FORMAT(1X,'P-',A2,'(S)=',G14.7,'  | PD-',A2,'(S)=',G14.7)
1050  FORMAT(1X,'   V(0)=',G14.7,'  |     RO(0)=',G14.7)
1060  FORMAT(1X,'V-',A2,'(0)=',G14.7,'  | RO-',A2,'(0)=',G14.7)
1070  FORMAT(1X,'   P(0)=',G14.7,'  |     PD(0)=',G14.7)
1080  FORMAT(1X,'P-',A2,'(0)=',G14.7,'  | PD-',A2,'(0)=',G14.7)
1090  FORMAT(1X,'   M(S)=',G14.7,'  |    PM(S)=',G14.7)
1100  FORMAT(1X,'  HI(S)=',G14.7,'  |    PH(S)=',G14.7)
1110  FORMAT(' Average potential over the sphere boundaries is ',G14.7)
1120  FORMAT(' Average potential in the interstitial region is ',G14.7)
1130  FORMAT(' Total charge in the interstitial region must be ',G14.7)
1140  FORMAT(' Total charge found  via  fourier  transform  is ',G14.7)
1150  FORMAT(' Auxilary density renormalization coefficient is ',G14.7)
1160  FORMAT(' Magnetization  in  the  interstitial region  is ',G14.7)
1170  FORMAT(' Total magnetization found in elementary cell is ',G14.7)
	RETURN
	END



	SUBROUTINE PRINTC(KEY)
*******************************************************
*  Prints input-output charge.                        *
*******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSV(NSORTMAX),ILSB(NSORTMAX)
	COMPLEX*16 SMTINP(NPAT),SMTOUT(NPAT)
     &   ,PSMOM(NSYMMAX,NPAT,NSPINMAX),AMTOT(NSYMMAX,NPAT,NSPINMAX)
     &   ,RHOPS(0:NPLWMAX,NSPINMAX),RHOPS1(0:NPLWMAX,NSPINMAX)
	DIMENSION Z(NSORTMAX),ZCOR(NSORTMAX),ORTH(2:3)
	CHARACTER TXTEL(NSORTMAX)*10
	COMMON /CONTROL/LIFT,LMTO,NCOU,NOVR,NPF                 !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM           !!! from init
	COMMON /MULTRO/ Z,ZCOR,AMTOT,PSMOM                      !!! from multro
	COMMON /PSRHO/  RHOPS,RHOPS1                            !!! from vcftr
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                         !!! from init
	COMMON /SPIN/   NSPIN                                   !!! from init
	COMMON /TXTEL/  TXTEL                                   !!! from init
	COMMON /UNIT/   IUN                                     !!! from init
	SAVE SMTINP,SININP,ZININP
	DATA PI/3.141592653589793D0/
C  SAVE INPUT CHARGE TRANSFER
	IF(KEY.EQ.1)THEN
	SININP=0.D0
	ZININP=OMEGAC*(RHOPS(0,1)+RHOPS(0,NSPIN))/2.D0*DBLE(NSPIN)
	DO 10 IATOM=1,NATOM
	SMTINP(IATOM)=(AMTOT(1,IATOM,1)+AMTOT(1,IATOM,NSPIN))/
     &  2.D0*DBLE(NSPIN)
	SININP=SININP-SMTINP(IATOM)
	ZININP=ZININP-(PSMOM(1,IATOM,1)+PSMOM(1,IATOM,NSPIN))/
     &  2.D0*DBLE(NSPIN)
   10   CONTINUE
	ELSEIF(KEY.EQ.2)THEN
	SINOUT=0.D0
	ZINOUT=OMEGAC*(RHOPS(0,1)+RHOPS(0,NSPIN))/2.D0*DBLE(NSPIN)
	DO 20 IATOM=1,NATOM
	SMTOUT(IATOM)=(AMTOT(1,IATOM,1)+AMTOT(1,IATOM,NSPIN))/
     &  2.D0*DBLE(NSPIN)
	SINOUT=SINOUT-SMTOUT(IATOM)
	ZINOUT=ZINOUT-(PSMOM(1,IATOM,1)+PSMOM(1,IATOM,NSPIN))/
     &  2.D0*DBLE(NSPIN)
   20   CONTINUE
C  PRINT CELL CHARGES
	WRITE(IUN,1010)
	WRITE(IUN,1020)
	DO 30 IATOM=1,NATOM
	WRITE(IUN,1030)DREAL(SMTINP(IATOM)),DREAL(SMTOUT(IATOM)),
     &  TXTEL(IS(IATOM))
   30   CONTINUE
	WRITE(IUN,1040)
	WRITE(IUN,1030)SININP,SINOUT
	WRITE(IUN,1030)ZININP,ZINOUT
	ENDIF
1010    FORMAT(1X,'Input/output charge transfer at the iteration  --->')
1020    FORMAT(1X,'    S(inp)              S(out)')
1030    FORMAT(1X,G14.7,6X,G14.7,2X,A)
1040    FORMAT(1X,'    I(inp)              I(out)')
	END
