	SUBROUTINE QVECTOR
************************************************************
*  Sets perturbation vector and mixing values.             *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NITER(0:NENVMAX,-1:2),KEY(0:NENVMAX,-1:2),KSP(0:NENVMAX,-1:2)
     &   ,LBROY(0:NENVMAX,-1:2),IBROY(0:NENVMAX,-1:2)
     &   ,NQDIV(3),NDIV(3),NRAD0(NSORTMAX),ILSV0(NSORTMAX)
	DIMENSION EPS(0:NENVMAX,-1:2),TAU(3,NPAT),ORTH(2:3)
     &   ,A(3,3),G(3,3),QPNT(3),QPNT0(3),AK(3,3),RK(3,3)
     &   ,ADMIX1(0:NENVMAX,-1:2),ADMIN (0:NENVMAX,-1:2)
     &   ,ADMAX (0:NENVMAX,-1:2),ADMIXB(0:NENVMAX,-1:2)
     &   ,ADMSPN(0:NENVMAX,-1:2),ASMIN (0:NENVMAX,-1:2)
     &   ,ASMAX (0:NENVMAX,-1:2),ADMIXH(0:NENVMAX,-1:2)
     &   ,GPTB(3,0:NENVMAX),GPTB0(3)
	CHARACTER*60 INIFILE,SC0FILE,STRFILE,SCRFILE(100)
     &   ,HUBFILE,HOPFILE,OPTFILE,ENRFILE,PNTFILE
     &   ,CONFILE,FTRFILE,KOVFILE,PSIFILE,TMPFILE
     &   ,BNDFILE,POTFILE,FATFILE,DOSFILE,SCFFILE
     &   ,OUTFILE
        CHARACTER*60 SCNFILE(0:NENVMAX,-1:2,100)
     &   ,DROFILE(0:NENVMAX,-1:2),DPSFILE(0:NENVMAX,-1:2)
     &   ,DSVFILE(0:NENVMAX,-1:2),DPVFILE(0:NENVMAX,-1:2)
     &   ,DSFFILE,PHNFILE,TMLFILE,WGTFILE(10),DFILE,TXTSCR
        CHARACTER*60 PLZFILE(NENVMAX),PLSFILE(NENVMAX)
     &   ,SCPFILE(NENVMAX,100)
	CHARACTER TEXQ*10,TXTEL(NSORTMAX)*10,TXTSP(2)*2,UN(100)*2
     &   ,TEXM*60,TASK*10,RS*10,TPOL(-1:2)*10,TZPTB(NENVMAX)*10,TW*3
     &   ,TEXOM*10,TGPTB(0:NENVMAX)*10
	LOGICAL EXIST
C Controls:
        COMMON /CONTROL/ LIFT,LMTO,NSPH,NINT,NPF,MODE        !!! from init
        COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
	COMMON /SPIN/    NSPIN                               !!! from init
	COMMON /PLZCOM/  NPLZ,LPLZ,IPLZ                      !!! from init
	COMMON /WHICOM/  NWHI,LWHI,IWHI                      !!! from init
C Inputs:
	COMMON /LATTICE/ A,G,AK,RK                           !!! from init
	COMMON /BASIS/   TAU                                 !!! from init
	COMMON /QMESH/   NQPNT,QPNT,NUMQ,NQDIV,KEYQ          !!! from init
        COMMON /MAGCOM/  ITERMAX,NITER,EPS                   !!! from init
	COMMON /PTBCOM/  NGSHL,NGPTB,GPTB                    !!! from init
        COMMON /INTTR/   NDIV                                !!! from init
	COMMON /LATPAR/  PAR,ORTH,OMEGAC                     !!! from init
C Mixings:
        COMMON /MIXDRHO/ ADMIX1,ADMIN,ADMAX,KEY              !!! from init
        COMMON /MIXDMAG/ ADMSPN,ASMIN,ASMAX,KSP              !!! from init
        COMMON /MIXDBRD/ LBROY,IBROY,ADMIXB,ADMIXH           !!! from init
C Additional inputs:
        COMMON /INP0/    INIFILE,SC0FILE,STRFILE             !!! from init
        COMMON /INP1/    ICHUB,ICHOP,ICOPT,ICENR,ICPNT       !!! from readini
        COMMON /INP2/    HUBFILE,HOPFILE,OPTFILE,ENRFILE,PNTFILE
C Frequency:
	COMMON /FREQU/   OMGR                                !!! from init
C Outputs:
        COMMON /OUT0/    SCRFILE
        COMMON /OUT1/    ICCON,ICFTR,ICKOV,ICPSI,ICTMP,ICBND !!! from readini
     &                  ,ICPOT,ICFAT,ICDOS,ICSCF,ICOUT
        COMMON /OUT2/    CONFILE,FTRFILE,KOVFILE,PSIFILE,TMPFILE
     &                  ,BNDFILE,POTFILE,FATFILE,DOSFILE,SCFFILE
     &                  ,OUTFILE
        COMMON /OUT0PH/  SCNFILE,DROFILE,DSVFILE,DPSFILE,DPVFILE!from init
        COMMON /OUT1PH/  ICDSF,ICDRO,ICPHN,ICTML,ICDSV,ICWGT !!! from init
        COMMON /OUT2PH/  DSFFILE,PHNFILE,TMLFILE,WGTFILE     !!! from init
        COMMON /OUT4PH/  SCPFILE,PLZFILE,PLSFILE             !!! from init
	COMMON /SCRDIR/  TXTSCR                              !!! from block
        COMMON /TXTEL/   TXTEL,TXTSP,TEXQ,TEXM,TASK,TEXOM    !!! from init
	COMMON /UNIT/    IUN,IUT,IUR                         !!! from init
	DATA PI/3.141592653589793D0/
C--------------------------------------------
C *** READ Q-VECTOR FROM PNTFILE ************
C--------------------------------------------
	OPEN(UNIT=1,FILE=PNTFILE,STATUS='OLD',FORM='FORMATTED')
	READ(1,*)NQPNT,NQDIV(1),NQDIV(2),NQDIV(3)
	DO ISKIP=1,5
	READ(1,*)
	ENDDO
	DO IPNT=1,NQPNT
	READ(1,*)IQPNT,(QPNT(I),I=1,3)
	IF(IQPNT.EQ.NUMQ)EXIT
	ENDDO
        CLOSE(1)
C--------------------------------------------
C *** READ G-VECTOR FROM PNTFILE ************
C--------------------------------------------
	OPEN(UNIT=1,FILE=PNTFILE,STATUS='OLD',FORM='FORMATTED')
	DO ISKIP=1,NQPNT+8
	READ(1,*)
	ENDDO
	DO IGSHL=0,NGSHL
	READ(1,*)IGPTB,(GPTB(I,IGPTB),I=1,3),ABSG,NGS,NGV
	BACKSPACE(1)
	DO IGV=1,NGV
	READ(1,*)IGPTB,(GPTB(I,IGPTB),I=1,3)
	ENDDO
	ENDDO
	NGPTB=IGPTB
        CLOSE(1)
C ACCOUNT FOR ORTHOROMBICITY PARAMETERS
	QPNT(1)=QPNT(1)
	QPNT(2)=QPNT(2)/ORTH(2)
	QPNT(3)=QPNT(3)/ORTH(3)
C--------------------------------------------
C *** SET OUTPUT FILE NAMES *****************
C--------------------------------------------
C CHANNEL ABBREVIATIONS
	DO ICHN=1,99
        IF(ICHN.LE.9)WRITE(RS,FMT='(I1)')ICHN
        IF(ICHN.GT.9)WRITE(RS,FMT='(I2)')ICHN
        IF(ICHN.GT.99)STOP'<QVECTOR>:: ICHN>99 NOT ASSUMED'
        NRS=INDEX(RS,' ')
        IF(ICHN.LE.9)RS='0'//RS(:NRS-1)
        IF(ICHN.GT.9)RS=RS(:NRS-1)
        NRS=INDEX(RS,' ')
	UN(ICHN)=RS(:NRS-1)
	ENDDO
C POLARIZATION ABBREVIATIONS
        DO MY=-1,2
        IF(MY.EQ.-1)TPOL(MY)='m'
        IF(MY.EQ. 0)TPOL(MY)='z'
        IF(MY.EQ.+1)TPOL(MY)='p'
        IF(MY.EQ.+2)TPOL(MY)='v'
	ENDDO
C RECIPROCAL VECTORS FOR PERTURBATION
	DO IGPTB=0,NGPTB
        IF(IGPTB.LE.9)                  WRITE(RS,FMT='(I1)')IGPTB
        IF(IGPTB.GT.9 .AND.IGPTB.LE.99) WRITE(RS,FMT='(I2)')IGPTB
        IF(IGPTB.GT.99.AND.IGPTB.LE.999)WRITE(RS,FMT='(I3)')IGPTB
        IF(IGPTB.GT.999)STOP'<QVECTOR>:: NGPTB>999 NOT ASSUMED'
        NRS=INDEX(RS,' ')
	TGPTB(IGPTB)=RS(:NRS-1)
	ENDDO
C RECIPROCAL VECTORS FOR POLARIZABILITY
	DO IZPTB=1,MIN(NENVMAX,999)
        IF(IZPTB.LE.9)                  WRITE(RS,FMT='(I1)')IZPTB
        IF(IZPTB.GT.9 .AND.IZPTB.LE.99) WRITE(RS,FMT='(I2)')IZPTB
        IF(IZPTB.GT.99.AND.IZPTB.LE.999)WRITE(RS,FMT='(I3)')IZPTB
        IF(IZPTB.GT.999)STOP'<QVECTOR>:: NZPTB>999 NOT ASSUMED'
        NRS=INDEX(RS,' ')
	TZPTB(IZPTB)=RS(:NRS-1)
	ENDDO
C TASK ABBREVIATION
	ND=INDEX(TASK,' ')
	IF(ND.LE.1)ND=2
C Q-POINT ABBREVIATIONS
        NQ=INDEX(TEXQ,' ')
        IF(NQ.LE.1)NQ=2
C FREQUENCY ABBREVIATION
	NO=INDEX(TEXOM,' ')
	IF(NO.LE.1)NO=2
C TETRAHEDRON WEIGHTS 
	DFILE=WGTFILE(1)
        NA=INDEX(DFILE,' ')
	IF(LWHI.EQ.1)TW='riw' ! real+imaginary part at finite omega 
	IF(LWHI.EQ.4)TW='imw' ! frequency dependent imaginary part
	WGTFILE(LWHI)=DFILE(:NA-1)//TEXQ(:NQ-1)//'w'//TEXOM(:NO-1)
        INQUIRE(FILE=WGTFILE(LWHI),EXIST=EXIST)
        IF(EXIST.AND.ICWGT.EQ.1)THEN
        PRINT*,
     &  '<QVECTOR>:: WGTFILE EXIST, WILL BE CHECKED'
        ICWGT=2
        ELSEIF(.NOT.EXIST.AND.ICWGT.EQ.2)THEN
        PRINT*,
     &  '<QVECTOR>:: WGTFILE DOES NOT EXIST, WILL BE CREATED'
        ICWGT=1
        ENDIF
C TEMPORARY FILE
        NA=INDEX(TMLFILE,' ')
        TMLFILE=TMLFILE(:NA-1)//TEXQ(:NQ-1)//'w'//TEXOM(:NO-1)
        INQUIRE(FILE=TMLFILE,EXIST=EXIST)
        IF(EXIST.AND.ICTML.EQ.1)
     &  STOP'<QVECTOR>:: TMPFILE EXIST, DELETE IT !'
C POLARIZABILITY FUNCTION
	IF(LPLZ.NE.0)THEN
	DFILE=PLZFILE(1)
        NA=INDEX(DFILE,' ')
	DO IZPTB=1,NENVMAX
        NRS=INDEX(TZPTB(IZPTB),' ')
        PLZFILE(IZPTB)=DFILE(:NA-1)//TEXQ(:NQ-1)//'w'//TEXOM(:NO-1)
     &  //'g'//TZPTB(IZPTB)(:NRS-1)
        INQUIRE(FILE=PLZFILE(IZPTB),EXIST=EXIST)
        IF(EXIST.AND.IZPTB.EQ.1.AND.IPLZ.EQ.1)THEN
        PRINT*,'<QVECTOR>:: PLZFILE  EXIST, WILL BE CHECKED'
        IPLZ=2
        ELSEIF(.NOT.EXIST.AND.IZPTB.EQ.1.AND.IPLZ.EQ.2)THEN
        PRINT*,'<QVECTOR>:: PLZFILE DOES NOT EXIST, WILL BE CREATED'
        IPLZ=1
        ENDIF
	ENDDO
	DFILE=PLSFILE(1)
        NA=INDEX(DFILE,' ')
	DO IZPTB=1,NENVMAX
        NRS=INDEX(TZPTB(IZPTB),' ')
        PLSFILE(IZPTB)=DFILE(:NA-1)//TEXQ(:NQ-1)//'w'//TEXOM(:NO-1)
     &  //'g'//TZPTB(IZPTB)(:NRS-1)
        INQUIRE(FILE=PLSFILE(IZPTB),EXIST=EXIST)
        IF(EXIST.AND.IZPTB.EQ.1.AND.IPLZ.EQ.1)THEN
        PRINT*,'<QVECTOR:: PLSFILE  EXIST, WILL BE CHECKED'
        IPLZ=2
        ELSEIF(.NOT.EXIST.AND.IZPTB.EQ.1.AND.IPLZ.EQ.2)THEN
        PRINT*,'<QVECTOR:: PLSFILE DOES NOT EXIST, WILL BE CREATED'
        IPLZ=1
        ENDIF
	ENDDO
	ENDIF
C CHANGE IN THE FULL POTENTIAL AND PSEUDOPOTENTIAL
	DFILE=DSVFILE(0,-1)
        NA=INDEX(DFILE,' ')
	DO MY=-1,2
	DO IGPTB=0,NGPTB
        NRS=INDEX(TGPTB(IGPTB),' ')
	IF(NITER(IGPTB,MY).NE.0)THEN
        NT=INDEX(TPOL(MY),' ')
        DSVFILE(IGPTB,MY)=DFILE(:NA-1)//TEXQ(:NQ-1)
     &  //'g'//TGPTB(IGPTB)(:NRS-1)//'w'//TEXOM(:NO-1)
     &  //TPOL(MY)(:NT-1)
        INQUIRE(FILE=DSVFILE(IGPTB,MY),EXIST=EXIST)
        IF(EXIST.AND.ICDSV.EQ.1)
     &  STOP'<QVECTOR>:: DSVFILE EXIST, DELETE IT !'
	ENDIF 
	ENDDO
	ENDDO
	DFILE=DPVFILE(0,-1)
        NA=INDEX(DFILE,' ')
	DO MY=-1,2
	DO IGPTB=0,NGPTB
        NRS=INDEX(TGPTB(IGPTB),' ')
	IF(NITER(IGPTB,MY).NE.0)THEN
        NT=INDEX(TPOL(MY),' ')
        DPVFILE(IGPTB,MY)=DFILE(:NA-1)//TEXQ(:NQ-1)
     &  //'g'//TGPTB(IGPTB)(:NRS-1)//'w'//TEXOM(:NO-1)
     &  //TPOL(MY)(:NT-1)
        INQUIRE(FILE=DPVFILE(IGPTB,MY),EXIST=EXIST)
        IF(EXIST.AND.ICDSV.EQ.1)
     &  STOP'<QVECTOR>:: DPVFILE EXIST, DELETE IT !'
	ENDIF
	ENDDO
	ENDDO
C CHANGE IN CHARGE DENSITY
	DFILE=DROFILE(0,-1)
        NA=INDEX(DFILE,' ')
	DO MY=-1,2
	DO IGPTB=0,NGPTB
        NRS=INDEX(TGPTB(IGPTB),' ')
	IF(NITER(IGPTB,MY).NE.0)THEN
        NT=INDEX(TPOL(MY),' ')
        DROFILE(IGPTB,MY)=DFILE(:NA-1)//TEXQ(:NQ-1)
     &  //'g'//TGPTB(IGPTB)(:NRS-1)//'w'//TEXOM(:NO-1)
     &  //TPOL(MY)(:NT-1)
        INQUIRE(FILE=DROFILE(IGPTB,MY),EXIST=EXIST)
        IF(EXIST.AND.MODE.EQ.1)THEN
        STOP'<QVECTOR>:: DROFILE EXIST, DELETE IT !'
        ELSEIF(.NOT.EXIST.AND.(MODE.EQ.2.OR.MODE.EQ.3))THEN
        PRINT*,'<QVECTOR>:: DROFILE DOES NOT EXIST !'
        ENDIF
	ENDIF
	ENDDO
	ENDDO
	DFILE=DPSFILE(0,-1)
        NA=INDEX(DFILE,' ')
	DO MY=-1,2
	DO IGPTB=0,NGPTB
        NRS=INDEX(TGPTB(IGPTB),' ')
	IF(NITER(IGPTB,MY).NE.0)THEN
        NT=INDEX(TPOL(MY),' ')
        DPSFILE(IGPTB,MY)=DFILE(:NA-1)//TEXQ(:NQ-1)
     &  //'g'//TGPTB(IGPTB)(:NRS-1)//'w'//TEXOM(:NO-1)
     &  //TPOL(MY)(:NT-1)
        INQUIRE(FILE=DPSFILE(IGPTB,MY),EXIST=EXIST)
        IF(EXIST.AND.MODE.EQ.1)THEN
        STOP'<QVECTOR>:: DPSFILE EXIST, DELETE IT !'
        ELSEIF(.NOT.EXIST.AND.(MODE.EQ.2.OR.MODE.EQ.3))THEN
        PRINT*,'<QVECTOR>:: DPSFILE DOES NOT EXIST !'
        ENDIF
	ENDIF
	ENDDO
	ENDDO
C OUTPUT FILE
        NA=INDEX(OUTFILE,' ')
        OUTFILE=OUTFILE(:NA-1)//TEXQ(:NQ-1)//'w'//TEXOM(:NO-1)
     &  //TASK(:ND-1)
        INQUIRE(FILE=OUTFILE,EXIST=EXIST)
        IF(EXIST.AND.ICOUT.EQ.1)THEN
        STOP'<QVECTOR>:: OUTFILE EXIST, DELETE IT !'
        ELSEIF(EXIST.AND.ICOUT.EQ.2)THEN
        OPEN(UNIT=1,FILE=OUTFILE,FORM='FORMATTED',STATUS='OLD')
        NA=INDEX(OUTFILE,' ')
        PRINT*,OUTFILE(:NA-1)//' DELETED !'
        CLOSE(UNIT=1,STATUS='DELETE')
        ENDIF
        IF(ICOUT.NE.IUT)THEN
        IUN=2
        OPEN(UNIT=2,FILE=OUTFILE,STATUS='NEW')
        ELSE
        IUN=IUT
        ENDIF
C SET SCRATCH FILES
	NS=INDEX(TXTSCR,' ')
	IF(NS.EQ.0)NS=1
	NA=INDEX(SCRFILE(1),' ')
	DFILE=TXTSCR(:NS-1)//SCRFILE(1)(:NA-1)
        NA=INDEX(DFILE,' ')
        DO ICHN=1,99 
        SCRFILE(ICHN)=DFILE(:NA-1)//UN(ICHN)
     &  //'q'//TEXQ(:NQ-1)//'w'//TEXOM(:NO-1)//TASK(:ND-1)
	ENDDO
        DO ICHN=1,99
        INQUIRE(FILE=SCRFILE(ICHN),EXIST=EXIST)
        IF(EXIST)THEN
        OPEN(UNIT=1,FILE=SCRFILE(ICHN),FORM='UNFORMATTED',
     &  STATUS='OLD')
        NA=INDEX(SCRFILE(ICHN),' ')
        PRINT*,SCRFILE(ICHN)(:NA-1)//' DELETED !'
        CLOSE(UNIT=1,STATUS='DELETE')
	ENDIF
	ENDDO
C SET SCRATCH FILES NAMED FOR EVERY POLARIZATION
        DO ICHN=1,99
        NS=INDEX(SCRFILE(ICHN),' ')
        DO MY=-1,2
        NT=INDEX(TPOL(MY),' ')
	DO IGPTB=0,NGPTB
        NRS=INDEX(TGPTB(IGPTB),' ')
        SCNFILE(IGPTB,MY,ICHN)=SCRFILE(ICHN)(:NS-1)
     &  //'g'//TGPTB(IGPTB)(:NRS-1)//TPOL(MY)(:NT-1)
        INQUIRE(FILE=SCNFILE(IGPTB,MY,ICHN),EXIST=EXIST)
        IF(EXIST)THEN
        OPEN(UNIT=1,FILE=SCNFILE(IGPTB,MY,ICHN),FORM='UNFORMATTED',
     &  STATUS='OLD')
        NA=INDEX(SCNFILE(IGPTB,MY,ICHN),' ')
        PRINT*,SCNFILE(IGPTB,MY,ICHN)(:NA-1)//' DELETED !'
        CLOSE(UNIT=1,STATUS='DELETE')
        ENDIF
	ENDDO
	ENDDO
	ENDDO
C SCRATCH FILES FOR POLARIZABILITY
	DO ICHN=1,99
        NS=INDEX(SCRFILE(ICHN),' ')
	DO IZPTB=1,NENVMAX
        NRS=INDEX(TZPTB(IZPTB),' ')
        SCPFILE(IZPTB,ICHN)=SCRFILE(ICHN)(:NS-1)
     &  //'g'//TZPTB(IZPTB)(:NRS-1)
        INQUIRE(FILE=SCPFILE(IZPTB,ICHN),EXIST=EXIST)
        IF(EXIST)THEN
        OPEN(UNIT=1,FILE=SCPFILE(IZPTB,ICHN),FORM='UNFORMATTED',
     &  STATUS='OLD')
        NA=INDEX(SCPFILE(IZPTB,ICHN),' ')
        PRINT*,SCPFILE(IZPTB,ICHN)(:NA-1)//' DELETED !'
        CLOSE(UNIT=1,STATUS='DELETE')
        ENDIF
	ENDDO
	ENDDO
C--------------------------------------------
C *** SET MIXING PARAMETERS *****************
C--------------------------------------------
	DO MY=-1,2
	DO IGPTB=0,NGPTB
        ADMIN(IGPTB,MY)=MAX(0.D0,ADMIX1(IGPTB,MY)/2.D0)
        ADMAX(IGPTB,MY)=MIN(1.D0,ADMIX1(IGPTB,MY)*2.D0)
	ASMIN(IGPTB,MY)=ADMSPN(IGPTB,MY) 
	ASMAX(IGPTB,MY)=ADMSPN(IGPTB,MY) 
	ENDDO
	ENDDO
C CHECK FOR START BROYDEN MODE
	DO MY=-1,2
	DO IGPTB=0,NGPTB
	IF(MODE.NE.2.AND.IBROY(IGPTB,MY).EQ.0)IBROY(IGPTB,MY)=1
	ENDDO
	ENDDO
C RESET MIXING ACCORDING TO WHAT IS STORED IN DROFILES
	DO 2000 MY=-1,2
	DO 1000 IGPTB=0,NGPTB
	IF(NITER(IGPTB,MY).EQ.0)GOTO1000
        INQUIRE(FILE=DROFILE(IGPTB,MY),EXIST=EXIST)
	IF(.NOT.EXIST)GOTO1000
	OPEN(UNIT=32,FILE=DROFILE(IGPTB,MY),STATUS='OLD',
     &  FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
        READ(32)NATOM0,NSORT0,NSPIN0,(NRAD0(ISORT),ISORT=1,NSORT),
     &  (ILSV0(ISORT),ISORT=1,NSORT0),(QPNT0(I),I=1,3),
     &  (GPTB0(I),I=1,3),OMGR0,NITER0,EPS0,KEY0,KSP0,LBROY0,ADMIN0,
     &  ADMAX0,ASMIN0,ASMAX0,ADMIXB0,ADMIXH0,CONVDRHO,CONVDMAG
	CLOSE(32)
	IF(NATOM0.NE.NATOM)STOP' # OF ATOMS MISMATCH IN <DROFILE>'
        IF(NSORT0.NE.NSORT)STOP' # OF SORTS MISMATCH IN <DROFILE>'
        IF(NSPIN0.NE.NSPIN)STOP' # OF SPINS MISMATCH IN <DROFILE>'
	IF(ABS((QPNT(1)-QPNT0(1))**2+(QPNT(2)-QPNT0(2))**2+
     &  (QPNT(3)-QPNT0(3))**2).GE.1.D-10)
     &  PRINT*,'Q-POINT  MISMATCHES IN <DROFILE>'
	IF(ABS((GPTB(1,IGPTB)-GPTB0(1))**2+
     &         (GPTB(2,IGPTB)-GPTB0(2))**2+
     &         (GPTB(3,IGPTB)-GPTB0(3))**2).GE.1.D-10)
     &  PRINT*,'G-POINT  MISMATCHES IN <DROFILE>'
	IF(ABS(OMGR-OMGR0).GE.1.D-10)
     &  PRINT*,'FREQUENCY MISMATCHES IN <DROFILE>'
        DO ISORT=1,NSORT
        IF(NRAD0(ISORT).GT.NRADMAX)STOP'NRAD>NRADMAX IN <DROFILE>'
        IF(ILSV0(ISORT).GT.LMAXV  )STOP'ILSV>LMAXV   IN <DROFILE>'
        ENDDO
        NA=INDEX(DROFILE(IGPTB,MY),' ')
C  SWITCH OFF SOME MODES IF SELF-CONSISTENT
	ACCUR=MAX(SQRT(CONVDRHO),SQRT(CONVDMAG))
        IF((MODE.EQ.2.OR.MODE.EQ.3).AND.EPS(IGPTB,MY).GE.ACCUR)
     &  NITER(IGPTB,MY)=0
        WRITE(IUN,1010)ACCUR,EPS(IGPTB,MY),NITER(IGPTB,MY),
     &  DROFILE(IGPTB,MY)(:NA-1)
C  SET MIXING
        IF((MODE.EQ.2.OR.MODE.EQ.3).AND.KEY(IGPTB,MY).EQ.0)THEN
        ADMIN (IGPTB,MY)=ADMIN0
        ADMAX (IGPTB,MY)=ADMAX0
        ASMIN (IGPTB,MY)=ASMIN0
        ASMAX (IGPTB,MY)=ASMAX0
        ADMIX1(IGPTB,MY)=(ADMIN(IGPTB,MY)+ADMAX(IGPTB,MY))/2.D0
        ADMSPN(IGPTB,MY)=(ASMIN(IGPTB,MY)+ASMAX(IGPTB,MY))/2.D0
        ENDIF
1000	CONTINUE
2000	CONTINUE
1010	FORMAT(1X,'Accuracy reached=',G9.2,'; required=',G9.2,
     &  '; Niter set to ',I3,' for ',A)
	END
